oracle.jdbc

## Class OracleDatabaseMetaData

- java.lang.Object
- - oracle.jdbc.OracleDatabaseMetaData

All Implemented Interfaces:
  DatabaseMetaData, Wrapper, AdditionalDatabaseMetaData, oracle.jdbc.internal.ACProxyable, oracle.jdbc.internal.Monitor

    public class OracleDatabaseMetaData
    extends Object
    implements oracle.jdbc.internal.AdditionalDatabaseMetaData, oracle.jdbc.internal.Monitor

The oracle.jdbc.OracleDatabaseMetaData class along with oracle.jdbc.driver.OracleDatabaseMetaData implement the JDBC 3.0 DatabaseMetaData interface and in ojdbc6.jar and above, the JDBC4.0 DatabaseMetaData interface. Note that the object returned by a call to java.sql.Connection.getMetaData() for a connection from the Oracle driver will be an instance of oracle.jdbc.driver.OracleDatabaseMetaData. There are several proprietary methods which are defined in this class. Only public long getLobMaxLength() will be retained in future versions. The following are superseeded by standard methods public static int getDriverMajorVersionInfo public static int getDriverMinorVersionInfo public static String getDriverVersionInfo and are deprecated. public String getLobPrecision() is no longer meaningful and is deprecated.

### Nested Class Summary

Nested Classes
`protected static class` `OracleDatabaseMetaData.DataTypeSource`

### Nested classes/interfaces inherited from interface oracle.jdbc.internal.Monitor

`oracle.jdbc.internal.Monitor.CloseableLock, oracle.jdbc.internal.Monitor.WaitableMonitor`

### Field Summary

Fields
`protected Object` `acProxy`
`protected oracle.jdbc.internal.OracleConnection` `connection`
`protected static Pattern` `sqlEscapePattern`
`protected static String` `sqlEscapeRegex`
`protected static Pattern` `sqlWildcardPattern`
`protected static String` `sqlWildcardRegex`

### Fields inherited from interface java.sql.DatabaseMetaData

`functionColumnIn, functionColumnInOut, functionColumnOut, functionColumnResult, functionColumnUnknown, functionNoNulls, functionNoTable, functionNullable, functionNullableUnknown, functionResultUnknown, functionReturn, functionReturnsTable, importedKeyInitiallyDeferred, importedKeyInitiallyImmediate, importedKeyNoAction, importedKeyNotDeferrable, importedKeySetDefault, sqlStateSQL`

### Constructor Summary

Constructors
Constructor and Description
`OracleDatabaseMetaData(OracleConnection conn)` Deprecated. -- Please use the factory method java.sql.Connection.getMetaData()

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
`boolean` `allProceduresAreCallable()` Can all the procedures returned by getProcedures be called by the current user?
`boolean` `allTablesAreSelectable()` Can all the tables returned by getTable be SELECTed by the current user?
`boolean` `autoCommitFailureClosesAllResultSets()` Oracle does not close ResultSets when autocommit fails.
`boolean` `dataDefinitionCausesTransactionCommit()` Does a data definition statement within a transaction force the transaction to commit?
`boolean` `dataDefinitionIgnoredInTransactions()` Is a data definition statement within a transaction ignored?
`protected String` `datatypeQuery(OracleDatabaseMetaData.DataTypeSource src)`
`protected String` `datatypeQuery(OracleDatabaseMetaData.DataTypeSource src, String table)`
`boolean` `deletesAreDetected(int type)` Implements JDBC 2.0 DatabaseMetaData.deletesAreDetected.
`boolean` `doesMaxRowSizeIncludeBlobs()` Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?
`boolean` `generatedKeyAlwaysReturned()`
`String` `getAccessBanner()` Returns the access banner on this connection.
`Object` `getACProxy()`
`ResultSet` `getAttributes(String catalog, String schemaPattern, String typeNamePattern, String attributeNamePattern)` JDBC 3.0 Retrieves a description of the given attribute of the given type for a user-defined type (UDT) that is available in the given schema and catalog.
`String` `getAuditBanner()` Returns the audit banner on this connection.
`ResultSet` `getBestRowIdentifier(String catalog, String schema, String table, int scope, boolean nullable)` Get a description of a table's optimal set of columns that uniquely identifies a row.
`ResultSet` `getCatalogs()` Get the catalog names available in this database.
`String` `getCatalogSeparator()` What's the separator between catalog and table name?
`String` `getCatalogTerm()` What's the database vendor's preferred term for "catalog"?
`ResultSet` `getClientInfoProperties()`
`ResultSet` `getColumnPrivileges(String catalog, String schemaPattern, String tableNamePattern, String columnNamePattern)` Get a description of the access rights for a table's columns.
`ResultSet` `getColumns(String catalog, String schemaPattern, String tableNamePattern, String columnNamePattern)` Get a description of table columns available in a catalog.
`Connection` `getConnection()` Implements JDBC 2.0 DatabaseMetaData.getConnection.

`ResultSet`

`getCrossReference(String primaryCatalog, String primarySchema, String primaryTable, String foreignCatalog, String foreignSchema, String foreignTable)`
Get a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key.) This should normally return a single foreign key/primary key pair (most tables only import a foreign key from a table once.) They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

`int` `getDatabaseMajorVersion()` JDBC 3.0 Retrieves the major version number of the underlying database.
`int` `getDatabaseMinorVersion()` JDBC 3.0 Retrieves the minor version number of the underlying database.
`String` `getDatabaseProductName()` What's the name of this database product?
`String` `getDatabaseProductVersion()` What's the version of this database product?
`int` `getDefaultTransactionIsolation()` What's the database's default transaction isolation level? The values are defined in java.sql.Connection.
`int` `getDriverMajorVersion()` What's this JDBC driver's major version number?
`static int` `getDriverMajorVersionInfo()` Deprecated. -- use standard getDriverMajorVersion()
`int` `getDriverMinorVersion()` What's this JDBC driver's minor version number?
`static int` `getDriverMinorVersionInfo()` Deprecated. -- use JDBC standard method getDriverMinorVersion
`String` `getDriverName()` What's the name of this JDBC driver?
`static String` `getDriverNameInfo()` What's the name of this JDBC driver?
`String` `getDriverVersion()` What's the version of this JDBC driver?
`static String` `getDriverVersionInfo()` Deprecated. -- use standard getDriverVersion()
`ResultSet` `getExportedKeys(String catalog, String schema, String table)` Get a description of a foreign key columns that reference a table's primary key columns (the foreign keys exported by a table).
`String` `getExtraNameCharacters()` Get all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, 0-9 and _).
`ResultSet` `getFunctionColumns(String catalog, String schemaPattern, String functionNamePattern, String columnNamePattern)` Retrieves a description of the given catalog's system or user function parameters and return type.
`ResultSet` `getFunctions(String catalog, String schemaPattern, String functionNamePattern)` Return a result set that describes the matching functions.
`protected int` `getIdentifierLength()`
`String` `getIdentifierQuoteString()` What's the string used to quote SQL identifiers? This returns a space " " if identifier quoting isn't supported.
`ResultSet` `getImportedKeys(String catalog, String schema, String table)` Get a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table).
`ResultSet` `getIndexInfo(String catalog, String schema, String table, boolean unique, boolean approximate)` Get a description of a table's indices and statistics.
`int` `getJDBCMajorVersion()` JDBC 3.0 Retrieves the major JDBC version number for this driver.
`int` `getJDBCMinorVersion()` JDBC 3.0 Retrieves the minor JDBC version number for this driver.
`long` `getLobMaxLength()` The max size of a lob on the server for this connection.
`static String` `getLobPrecision()` Deprecated.
`int` `getMaxBinaryLiteralLength()` How many hex characters can you have in an inline binary literal?
`int` `getMaxCatalogNameLength()` What's the maximum length of a catalog name?
`int` `getMaxCharLiteralLength()` What's the max length for a character literal?
`int` `getMaxColumnNameLength()` What's the limit on column name length?
`int` `getMaxColumnsInGroupBy()` What's the maximum number of columns in a "GROUP BY" clause?
`int` `getMaxColumnsInIndex()` What's the maximum number of columns allowed in an index?
`int` `getMaxColumnsInOrderBy()` What's the maximum number of columns in an "ORDER BY" clause?
`int` `getMaxColumnsInSelect()` What's the maximum number of columns in a "SELECT" list?
`int` `getMaxColumnsInTable()` What's maximum number of columns in a table?
`int` `getMaxConnections()` How many active connections can we have at a time to this database?
`int` `getMaxCursorNameLength()` What's the maximum cursor name length?
`int` `getMaxIndexLength()` What's the maximum length of an index (in bytes)?
`int` `getMaxProcedureNameLength()` What's the maximum length of a procedure name?
`int` `getMaxRowSize()` What's the maximum length of a single row?
`int` `getMaxSchemaNameLength()` What's the maximum length allowed for a schema name?
`int` `getMaxStatementLength()` What's the maximum length of a SQL statement?
`int` `getMaxStatements()` How many active statements can we have open at one time to this database?
`int` `getMaxTableNameLength()` What's the maximum length of a table name?
`int` `getMaxTablesInSelect()` What's the maximum number of tables in a SELECT?
`int` `getMaxUserNameLength()` What's the maximum length of a user name?
`oracle.jdbc.internal.Monitor.CloseableLock` `getMonitorLock()`
`String` `getNumericFunctions()` Get a comma separated list of math functions.
`OracleTypeMetaData` `getOracleTypeMetaData(String sqlTypeName)` Return the type metadata for a named type.
`ResultSet` `getPrimaryKeys(String catalog, String schema, String table)` Get a description of a table's primary key columns.
`ResultSet` `getProcedureColumns(String catalog, String schemaPattern, String procedureNamePattern, String columnNamePattern)` Get a description of a catalog's stored procedure parameters and result columns.
`ResultSet` `getProcedures(String catalog, String schemaPattern, String procedureNamePattern)` Get a description of stored procedures available in a catalog.
`String` `getProcedureTerm()` What's the database vendor's preferred term for "procedure"?
`ResultSet` `getPseudoColumns(String catalog, String schemaPattern, String tableNamePattern, String columnNamePattern)`
`int` `getResultSetHoldability()` JDBC 3.0 Retrieves the default holdability of this `ResultSet` object.
`RowIdLifetime` `getRowIdLifetime()` Oracle rowids are valid across all sessions.
`ResultSet` `getSchemas()` Get the schema names available in this database.
`ResultSet` `getSchemas(String catalog, String schemaPattern)` Return the schemas that match the given pattern.
`String` `getSchemaTerm()` What's the database vendor's preferred term for "schema"?
`String` `getSearchStringEscape()` This is the string that can be used to escape '_' or '%' in the string pattern style catalog search parameters.
`String` `getSQLKeywords()` Get a comma separated list of all a database's SQL keywords that are NOT also SQL92 keywords.
`int` `getSQLStateType()` JDBC 3.0 Indicates whether the SQLSTATEs returned by `SQLException.getSQLState` is X/Open (now known as Open Group) SQL CLI or SQL99.
`String` `getStringFunctions()` Get a comma separated list of string functions.
`ResultSet` `getSuperTables(String catalog, String schemaPattern, String tableNamePattern)` JDBC 3.0 Retrieves a description of the table hierarchies defined in a particular schema in this database.
`ResultSet` `getSuperTypes(String catalog, String schemaPattern, String typeNamePattern)` JDBC 3.0 Retrieves a description of the user-defined type (UDT) hierarchies defined in a particular schema in this database.
`String` `getSystemFunctions()` Get a comma separated list of system functions.
`ResultSet` `getTablePrivileges(String catalog, String schemaPattern, String tableNamePattern)` Get a description of the access rights for each table available in a catalog.
`ResultSet` `getTables(String catalog, String schemaPattern, String tableNamePattern, String[] types)` Get a description of tables available in a catalog.
`ResultSet` `getTableTypes()` Get the table types available in this database.
`String` `getTimeDateFunctions()` Get a comma separated list of time and date functions.
`ResultSet` `getTypeInfo()` Get a description of all the standard SQL types supported by this database.
`ResultSet` `getUDTs(String catalog, String schemaPattern, String typeNamePattern, int[] types)` Implements JDBC 2.0 DatabaseMetaData::getUDTs.
`String` `getURL()` What's the url for this database?
`String` `getUserName()` What's our user name as known to the database?
`ResultSet` `getVersionColumns(String catalog, String schema, String table)` Get a description of a table's columns that are automatically updated when any value in a row is updated.
`protected boolean` `hasSqlWildcard(String s)`
`boolean` `insertsAreDetected(int type)` Implements JDBC 2.0 DatabaseMetaData.insertsAreDetected.
`boolean` `isCatalogAtStart()` Does a catalog appear at the start of a qualified table name? (Otherwise it appears at the end)
`boolean` `isCompatible122OrGreater()`
`boolean` `isReadOnly()` Is the database in read-only mode?
`boolean` `isServerBigSCN()`
`boolean` `isWrapperFor(Class<?> iface)` Since this class is not a wrapper, just check to see if this implements the requested interface.
`boolean` `locatorsUpdateCopy()` JDBC 3.0
`boolean` `nullPlusNonNullIsNull()` Are concatenations between NULL and non-NULL values NULL? A JDBC compliant driver always returns true.
`boolean` `nullsAreSortedAtEnd()` Are NULL values sorted at the end regardless of sort order?
`boolean` `nullsAreSortedAtStart()` Are NULL values sorted at the start regardless of sort order?
`boolean` `nullsAreSortedHigh()` Are NULL values sorted high?
`boolean` `nullsAreSortedLow()` Are NULL values sorted low?
`boolean` `othersDeletesAreVisible(int type)` Implements JDBC 2.0 DatabaseMetaData..
`boolean` `othersInsertsAreVisible(int type)` Implements JDBC 2.0 DatabaseMetaData.othersInsertsAreVisible.
`boolean` `othersUpdatesAreVisible(int type)` Implements JDBC 2.0 DatabaseMetaData..
`boolean` `ownDeletesAreVisible(int type)` Implements JDBC 2.0 DatabaseMetaData.ownDeletesAreVisible.
`boolean` `ownInsertsAreVisible(int type)` Implements JDBC 2.0 DatabaseMetaData.ownInsertsAreVisible.
`boolean` `ownUpdatesAreVisible(int type)` Implements JDBC 2.0 DatabaseMetaData.ownUpdatesAreVisible.
`void` `setACProxy(Object w)`
`boolean` `storesLowerCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in lower case?
`boolean` `storesLowerCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in lower case?
`boolean` `storesMixedCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in mixed case?
`boolean` `storesMixedCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in mixed case?
`boolean` `storesUpperCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in upper case?
`boolean` `storesUpperCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in upper case?
`protected String` `stripSqlEscapes(String s)`
`boolean` `supportsAlterTableWithAddColumn()` Is "ALTER TABLE" with add column supported?
`boolean` `supportsAlterTableWithDropColumn()` Is "ALTER TABLE" with drop column supported?
`boolean` `supportsANSI92EntryLevelSQL()` Is the ANSI92 entry level SQL grammar supported? All JDBC compliant drivers must return true.
`boolean` `supportsANSI92FullSQL()` Is the ANSI92 full SQL grammar supported?
`boolean` `supportsANSI92IntermediateSQL()` Is the ANSI92 intermediate SQL grammar supported?
`boolean` `supportsBatchUpdates()` Implements JDBC 2.0 DatabaseMetaData::supportBatchUpdates.
`boolean` `supportsCatalogsInDataManipulation()` Can a catalog name be used in a data manipulation statement?
`boolean` `supportsCatalogsInIndexDefinitions()` Can a catalog name be used in a index definition statement?
`boolean` `supportsCatalogsInPrivilegeDefinitions()` Can a catalog name be used in a privilege definition statement?
`boolean` `supportsCatalogsInProcedureCalls()` Can a catalog name be used in a procedure call statement?
`boolean` `supportsCatalogsInTableDefinitions()` Can a catalog name be used in a table definition statement?
`boolean` `supportsColumnAliasing()` Is column aliasing supported?
`boolean` `supportsConvert()` Is the CONVERT function between SQL types supported?
`boolean` `supportsConvert(int fromType, int toType)` Is CONVERT between the given SQL types supported?
`boolean` `supportsCoreSQLGrammar()` Is the ODBC Core SQL grammar supported?
`boolean` `supportsCorrelatedSubqueries()` Are correlated subqueries supported? A JDBC compliant driver always returns true.
`boolean` `supportsDataDefinitionAndDataManipulationTransactions()` Are both data definition and data manipulation statements within a transaction supported?
`boolean` `supportsDataManipulationTransactionsOnly()` Are only data manipulation statements within a transaction supported?
`boolean` `supportsDifferentTableCorrelationNames()` If table correlation names are supported, are they restricted to be different from the names of the tables?
`boolean` `supportsExpressionsInOrderBy()` Are expressions in "ORDER BY" lists supported?
`boolean` `supportsExtendedSQLGrammar()` Is the ODBC Extended SQL grammar supported?
`boolean` `supportsFullOuterJoins()` Are full nested outer joins supported?
`boolean` `supportsGetGeneratedKeys()` JDBC 3.0 Retrieves whether auto-generated keys can be retrieved after a statement has been executed.
`boolean` `supportsGroupBy()` Is some form of "GROUP BY" clause supported?
`boolean` `supportsGroupByBeyondSelect()` Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?
`boolean` `supportsGroupByUnrelated()` Can a "GROUP BY" clause use columns not in the SELECT?
`boolean` `supportsIntegrityEnhancementFacility()` Is the SQL Integrity Enhancement Facility supported?
`boolean` `supportsLikeEscapeClause()` Is the escape character in "LIKE" clauses supported? A JDBC compliant driver always returns true.
`boolean` `supportsLimitedOuterJoins()` Is there limited support for outer joins? (This will be true if supportFullOuterJoins is true.)
`boolean` `supportsMinimumSQLGrammar()` Is the ODBC Minimum SQL grammar supported? All JDBC compliant drivers must return true.
`boolean` `supportsMixedCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC compliant driver will always return false.
`boolean` `supportsMixedCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC compliant driver will always return false.
`boolean` `supportsMultipleOpenResults()` JDBC 3.0 Retrieves whether it is possible to have multiple `ResultSet` objects returned from a `CallableStatement` object simultaneously.
`boolean` `supportsMultipleResultSets()` Are multiple ResultSets from a single execute supported?
`boolean` `supportsMultipleTransactions()` Can we have multiple transactions open at once (on different connections)?
`boolean` `supportsNamedParameters()` JDBC 3.0 Retrieves whether this database supports named parameters to callable statements.
`boolean` `supportsNonNullableColumns()` Can columns be defined as non-nullable? A JDBC compliant driver always returns true.
`boolean` `supportsOpenCursorsAcrossCommit()` Can cursors remain open across commits?
`boolean` `supportsOpenCursorsAcrossRollback()` Can cursors remain open across rollbacks?
`boolean` `supportsOpenStatementsAcrossCommit()` Can statements remain open across commits?
`boolean` `supportsOpenStatementsAcrossRollback()` Can statements remain open across rollbacks?
`boolean` `supportsOrderByUnrelated()` Can an "ORDER BY" clause use columns not in the SELECT?
`boolean` `supportsOuterJoins()` Is some form of outer join supported?
`boolean` `supportsPositionedDelete()` Is positioned DELETE supported? NOTE: Though Oracle supports positional delete through the use of ROWID positional delete as specified by SQLJ92 standard is not supported which is being followed by JDBC 2.1 API Spec.
`boolean` `supportsPositionedUpdate()` Is positioned UPDATE supported? NOTE: Though Oracle supports positional updates through the use of ROWID positional updates as specified by SQLJ92 standard is not supported which is being followed by JDBC 2.1 API Spec.
`boolean` `supportsResultSetConcurrency(int type, int concurrency)` Implements JDBC 2.0 DatabaseMetaData.supportsResultSetConcurrency.
`boolean` `supportsResultSetHoldability(int holdability)` JDBC 3.0 Retrieves whether this database supports the given result set holdability.
`boolean` `supportsResultSetType(int type)` Implements JDBC 2.0 DatabaseMetaData.supportsResultSetType.
`boolean` `supportsSavepoints()` JDBC 3.0 Retrieves whether this database supports savepoints.
`boolean` `supportsSchemasInDataManipulation()` Can a schema name be used in a data manipulation statement?
`boolean` `supportsSchemasInIndexDefinitions()` Can a schema name be used in an index definition statement?
`boolean` `supportsSchemasInPrivilegeDefinitions()` Can a schema name be used in a privilege definition statement?
`boolean` `supportsSchemasInProcedureCalls()` Can a schema name be used in a procedure call statement?
`boolean` `supportsSchemasInTableDefinitions()` Can a schema name be used in a table definition statement?
`boolean` `supportsSelectForUpdate()` Is SELECT for UPDATE supported?
`boolean` `supportsStatementPooling()` JDBC 3.0
`boolean` `supportsStoredFunctionsUsingCallSyntax()` Oracle supports using the JDBC escape syntax to call PLSQL functions.
`boolean` `supportsStoredProcedures()` Are stored procedure calls using the stored procedure escape syntax supported?
`boolean` `supportsSubqueriesInComparisons()` Are subqueries in comparison expressions supported? A JDBC compliant driver always returns true.
`boolean` `supportsSubqueriesInExists()` Are subqueries in exists expressions supported? A JDBC compliant driver always returns true.
`boolean` `supportsSubqueriesInIns()` Are subqueries in "in" statements supported? A JDBC compliant driver always returns true.
`boolean` `supportsSubqueriesInQuantifieds()` Are subqueries in quantified expressions supported? A JDBC compliant driver always returns true.
`boolean` `supportsTableCorrelationNames()` Are table correlation names supported? A JDBC compliant driver always returns true.
`boolean` `supportsTransactionIsolationLevel(int level)` Does the database support the given transaction isolation level?
`boolean` `supportsTransactions()` Are transactions supported? If not, commit is a noop and the isolation level is TRANSACTION_NONE.
`boolean` `supportsUnion()` Is SQL UNION supported?
`boolean` `supportsUnionAll()` Is SQL UNION ALL supported?
`<T> T` `unwrap(Class<T> iface)` Since this class is not a wrapper, just check to see if this implements the requested interface.
`boolean` `updatesAreDetected(int type)` Implements JDBC 2.0 DatabaseMetaData.updatesAreDetected.
`boolean` `usesLocalFilePerTable()` Does the database use a file for each table?
`boolean` `usesLocalFiles()` Does the database store tables in a local file?

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.sql.DatabaseMetaData

`getMaxLogicalLobSize, supportsRefCursors`

### Methods inherited from interface oracle.jdbc.internal.Monitor

`acquireCloseableLock, acquireLock, newDefaultLock, newInstance, releaseLock`

### Field Detail

#### connection

    protected oracle.jdbc.internal.OracleConnection connection

#### sqlWildcardRegex

    protected static final String sqlWildcardRegex

See Also:
  Constant Field Values

#### sqlWildcardPattern

    protected static Pattern sqlWildcardPattern

#### sqlEscapeRegex

    protected static final String sqlEscapeRegex

See Also:
  Constant Field Values

#### sqlEscapePattern

    protected static Pattern sqlEscapePattern

#### acProxy

    protected Object acProxy

### Constructor Detail

#### OracleDatabaseMetaData

    public OracleDatabaseMetaData(OracleConnection conn)

Deprecated. -- Please use the factory method java.sql.Connection.getMetaData()

### Method Detail

#### allProceduresAreCallable

    public boolean allProceduresAreCallable()
                                     throws SQLException

Can all the procedures returned by getProcedures be called by the current user?

Specified by:
  `allProceduresAreCallable` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### allTablesAreSelectable

    public boolean allTablesAreSelectable()
                                   throws SQLException

Can all the tables returned by getTable be SELECTed by the current user?

Specified by:
  `allTablesAreSelectable` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### getURL

    public String getURL()
                  throws SQLException

What's the url for this database?

Specified by:
  `getURL` in interface `DatabaseMetaData`
Returns:
  the url or null if it can't be generated
Throws:
  `SQLException`

#### getUserName

    public String getUserName()
                       throws SQLException

What's our user name as known to the database?

Specified by:
  `getUserName` in interface `DatabaseMetaData`
Returns:
  our database user name
Throws:
  `SQLException`

#### isReadOnly

    public boolean isReadOnly()
                       throws SQLException

Is the database in read-only mode?

Specified by:
  `isReadOnly` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### nullsAreSortedHigh

    public boolean nullsAreSortedHigh()
                               throws SQLException

Are NULL values sorted high?

Specified by:
  `nullsAreSortedHigh` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### nullsAreSortedLow

    public boolean nullsAreSortedLow()
                              throws SQLException

Are NULL values sorted low?

Specified by:
  `nullsAreSortedLow` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### nullsAreSortedAtStart

    public boolean nullsAreSortedAtStart()
                                  throws SQLException

Are NULL values sorted at the start regardless of sort order?

Specified by:
  `nullsAreSortedAtStart` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### nullsAreSortedAtEnd

    public boolean nullsAreSortedAtEnd()
                                throws SQLException

Are NULL values sorted at the end regardless of sort order?

Specified by:
  `nullsAreSortedAtEnd` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### getDatabaseProductName

    public String getDatabaseProductName()
                                  throws SQLException

What's the name of this database product?

Specified by:
  `getDatabaseProductName` in interface `DatabaseMetaData`
Returns:
  database product name
Throws:
  `SQLException`

#### getDatabaseProductVersion

    public String getDatabaseProductVersion()
                                     throws SQLException

What's the version of this database product?

Specified by:
  `getDatabaseProductVersion` in interface `DatabaseMetaData`
Returns:
  database version
Throws:
  `SQLException`

#### getDriverName

    public String getDriverName()
                         throws SQLException

What's the name of this JDBC driver?

Specified by:
  `getDriverName` in interface `DatabaseMetaData`
Returns:
  JDBC driver name
Throws:
  `SQLException`

#### getDriverVersion

    public String getDriverVersion()
                            throws SQLException

What's the version of this JDBC driver?

Specified by:
  `getDriverVersion` in interface `DatabaseMetaData`
Returns:
  JDBC driver version
Throws:
  `SQLException`

#### getDriverMajorVersion

    public int getDriverMajorVersion()

What's this JDBC driver's major version number?

Specified by:
  `getDriverMajorVersion` in interface `DatabaseMetaData`
Returns:
  JDBC driver major version

#### getDriverMinorVersion

    public int getDriverMinorVersion()

What's this JDBC driver's minor version number?

Specified by:
  `getDriverMinorVersion` in interface `DatabaseMetaData`
Returns:
  JDBC driver minor version number

#### usesLocalFiles

    public boolean usesLocalFiles()
                           throws SQLException

Does the database store tables in a local file?

Specified by:
  `usesLocalFiles` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### usesLocalFilePerTable

    public boolean usesLocalFilePerTable()
                                  throws SQLException

Does the database use a file for each table?

Specified by:
  `usesLocalFilePerTable` in interface `DatabaseMetaData`
Returns:
  true if the database uses a local file for each table
Throws:
  `SQLException`

#### supportsMixedCaseIdentifiers

    public boolean supportsMixedCaseIdentifiers()
                                         throws SQLException

Does the database treat mixed case unquoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC compliant driver will always return false.

Specified by:
  `supportsMixedCaseIdentifiers` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### storesUpperCaseIdentifiers

    public boolean storesUpperCaseIdentifiers()
                                       throws SQLException

Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in upper case?

Specified by:
  `storesUpperCaseIdentifiers` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### storesLowerCaseIdentifiers

    public boolean storesLowerCaseIdentifiers()
                                       throws SQLException

Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in lower case?

Specified by:
  `storesLowerCaseIdentifiers` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### storesMixedCaseIdentifiers

    public boolean storesMixedCaseIdentifiers()
                                       throws SQLException

Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in mixed case?

Specified by:
  `storesMixedCaseIdentifiers` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsMixedCaseQuotedIdentifiers

    public boolean supportsMixedCaseQuotedIdentifiers()
                                               throws SQLException

Does the database treat mixed case quoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC compliant driver will always return false.

Specified by:
  `supportsMixedCaseQuotedIdentifiers` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### storesUpperCaseQuotedIdentifiers

    public boolean storesUpperCaseQuotedIdentifiers()
                                             throws SQLException

Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in upper case?

Specified by:
  `storesUpperCaseQuotedIdentifiers` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### storesLowerCaseQuotedIdentifiers

    public boolean storesLowerCaseQuotedIdentifiers()
                                             throws SQLException

Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in lower case?

Specified by:
  `storesLowerCaseQuotedIdentifiers` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### storesMixedCaseQuotedIdentifiers

    public boolean storesMixedCaseQuotedIdentifiers()
                                             throws SQLException

Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in mixed case?

Specified by:
  `storesMixedCaseQuotedIdentifiers` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### getIdentifierQuoteString

    public String getIdentifierQuoteString()
                                    throws SQLException

What's the string used to quote SQL identifiers? This returns a space " " if identifier quoting isn't supported. A JDBC compliant driver always uses a double quote character.

Specified by:
  `getIdentifierQuoteString` in interface `DatabaseMetaData`
Returns:
  the quoting string
Throws:
  `SQLException`

#### getSQLKeywords

    public String getSQLKeywords()
                          throws SQLException

Get a comma separated list of all a database's SQL keywords that are NOT also SQL92 keywords.

Specified by:
  `getSQLKeywords` in interface `DatabaseMetaData`
Returns:
  the list
Throws:
  `SQLException`

#### getNumericFunctions

    public String getNumericFunctions()
                               throws SQLException

Get a comma separated list of math functions. The following are supported

- ABS
- ACOS
- ASIN
- ATAN
- ATAN2
- CEILING
- COS
- EXP
- FLOOR
- LOG
- LOG10
- MOD
- PI
- POWER
- ROUND
- SIGN
- SIN
- SQRT
- TAN
- TRUNCATE

Specified by:
  `getNumericFunctions` in interface `DatabaseMetaData`
Returns:
  the list
Throws:
  `SQLException`

#### getStringFunctions

    public String getStringFunctions()
                              throws SQLException

Get a comma separated list of string functions. The following are supported

- ASCII
- CHAR
- CONCAT
- LCASE
- LENGTH
- LTRIM
- REPLACE
- RTRIM
- SOUNDEX
- SUBSTRING
- UCASE

In addition, the following are supported in a JDBC 4.0 environment

- OCTET_LENGTH
- CHAR_LENGTH
- CHARACTER_LENGTH

Specified by:
  `getStringFunctions` in interface `DatabaseMetaData`
Returns:
  the list
Throws:
  `SQLException`

#### getSystemFunctions

    public String getSystemFunctions()
                              throws SQLException

Get a comma separated list of system functions. The following are supported

- USER

Specified by:
  `getSystemFunctions` in interface `DatabaseMetaData`
Returns:
  the list
Throws:
  `SQLException`

#### getTimeDateFunctions

    public String getTimeDateFunctions()
                                throws SQLException

Get a comma separated list of time and date functions. The following are supported

- CURDATE
- HOUR
- MINUTE
- MONTH
- SECOND
- YEAR

In addition, the following are supported in a JDBC 4.0 environment.

- CURRENT_DATE
- CURRENT_TIMESTAMP
- EXTRACT

Specified by:
  `getTimeDateFunctions` in interface `DatabaseMetaData`
Returns:
  the list
Throws:
  `SQLException`

#### getSearchStringEscape

    public String getSearchStringEscape()
                                 throws SQLException

This is the string that can be used to escape '_' or '%' in the string pattern style catalog search parameters.

The '_' character represents any single character.

The '%' character represents any sequence of zero or more characters.

Specified by:
  `getSearchStringEscape` in interface `DatabaseMetaData`
Returns:
  the string used to escape wildcard characters
Throws:
  `SQLException`

#### getExtraNameCharacters

    public String getExtraNameCharacters()
                                  throws SQLException

Get all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, 0-9 and _).

Specified by:
  `getExtraNameCharacters` in interface `DatabaseMetaData`
Returns:
  the string containing the extra characters
Throws:
  `SQLException`

#### supportsAlterTableWithAddColumn

    public boolean supportsAlterTableWithAddColumn()
                                            throws SQLException

Is "ALTER TABLE" with add column supported?

Specified by:
  `supportsAlterTableWithAddColumn` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsAlterTableWithDropColumn

    public boolean supportsAlterTableWithDropColumn()
                                             throws SQLException

Is "ALTER TABLE" with drop column supported?

Specified by:
  `supportsAlterTableWithDropColumn` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsColumnAliasing

    public boolean supportsColumnAliasing()
                                   throws SQLException

Is column aliasing supported?

If so, the SQL AS clause can be used to provide names for computed columns or to provide alias names for columns as required. A JDBC compliant driver always returns true.

Specified by:
  `supportsColumnAliasing` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### nullPlusNonNullIsNull

    public boolean nullPlusNonNullIsNull()
                                  throws SQLException

Are concatenations between NULL and non-NULL values NULL? A JDBC compliant driver always returns true.

Specified by:
  `nullPlusNonNullIsNull` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsConvert

    public boolean supportsConvert()
                            throws SQLException

Is the CONVERT function between SQL types supported?

Specified by:
  `supportsConvert` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsConvert

    public boolean supportsConvert(int fromType,
                                   int toType)
                            throws SQLException

Is CONVERT between the given SQL types supported?

Specified by:
  `supportsConvert` in interface `DatabaseMetaData`
Parameters:
  `fromType` - the type to convert from
  `toType` - the type to convert to
Returns:
  true if so
Throws:
  `SQLException`
See Also:
  `Types`

#### supportsTableCorrelationNames

    public boolean supportsTableCorrelationNames()
                                          throws SQLException

Are table correlation names supported? A JDBC compliant driver always returns true.

Specified by:
  `supportsTableCorrelationNames` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsDifferentTableCorrelationNames

    public boolean supportsDifferentTableCorrelationNames()
                                                   throws SQLException

If table correlation names are supported, are they restricted to be different from the names of the tables?

Specified by:
  `supportsDifferentTableCorrelationNames` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsExpressionsInOrderBy

    public boolean supportsExpressionsInOrderBy()
                                         throws SQLException

Are expressions in "ORDER BY" lists supported?

Specified by:
  `supportsExpressionsInOrderBy` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsOrderByUnrelated

    public boolean supportsOrderByUnrelated()
                                     throws SQLException

Can an "ORDER BY" clause use columns not in the SELECT?

Specified by:
  `supportsOrderByUnrelated` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsGroupBy

    public boolean supportsGroupBy()
                            throws SQLException

Is some form of "GROUP BY" clause supported?

Specified by:
  `supportsGroupBy` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsGroupByUnrelated

    public boolean supportsGroupByUnrelated()
                                     throws SQLException

Can a "GROUP BY" clause use columns not in the SELECT?

Specified by:
  `supportsGroupByUnrelated` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsGroupByBeyondSelect

    public boolean supportsGroupByBeyondSelect()
                                        throws SQLException

Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?

Specified by:
  `supportsGroupByBeyondSelect` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsLikeEscapeClause

    public boolean supportsLikeEscapeClause()
                                     throws SQLException

Is the escape character in "LIKE" clauses supported? A JDBC compliant driver always returns true.

Specified by:
  `supportsLikeEscapeClause` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsMultipleResultSets

    public boolean supportsMultipleResultSets()
                                       throws SQLException

Are multiple ResultSets from a single execute supported?

Specified by:
  `supportsMultipleResultSets` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsMultipleTransactions

    public boolean supportsMultipleTransactions()
                                         throws SQLException

Can we have multiple transactions open at once (on different connections)?

Specified by:
  `supportsMultipleTransactions` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsNonNullableColumns

    public boolean supportsNonNullableColumns()
                                       throws SQLException

Can columns be defined as non-nullable? A JDBC compliant driver always returns true.

Specified by:
  `supportsNonNullableColumns` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsMinimumSQLGrammar

    public boolean supportsMinimumSQLGrammar()
                                      throws SQLException

Is the ODBC Minimum SQL grammar supported? All JDBC compliant drivers must return true.

Specified by:
  `supportsMinimumSQLGrammar` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsCoreSQLGrammar

    public boolean supportsCoreSQLGrammar()
                                   throws SQLException

Is the ODBC Core SQL grammar supported?

Specified by:
  `supportsCoreSQLGrammar` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsExtendedSQLGrammar

    public boolean supportsExtendedSQLGrammar()
                                       throws SQLException

Is the ODBC Extended SQL grammar supported?

Specified by:
  `supportsExtendedSQLGrammar` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsANSI92EntryLevelSQL

    public boolean supportsANSI92EntryLevelSQL()
                                        throws SQLException

Is the ANSI92 entry level SQL grammar supported? All JDBC compliant drivers must return true.

Specified by:
  `supportsANSI92EntryLevelSQL` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsANSI92IntermediateSQL

    public boolean supportsANSI92IntermediateSQL()
                                          throws SQLException

Is the ANSI92 intermediate SQL grammar supported?

Specified by:
  `supportsANSI92IntermediateSQL` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsANSI92FullSQL

    public boolean supportsANSI92FullSQL()
                                  throws SQLException

Is the ANSI92 full SQL grammar supported?

Specified by:
  `supportsANSI92FullSQL` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsIntegrityEnhancementFacility

    public boolean supportsIntegrityEnhancementFacility()
                                                 throws SQLException

Is the SQL Integrity Enhancement Facility supported?

Specified by:
  `supportsIntegrityEnhancementFacility` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsOuterJoins

    public boolean supportsOuterJoins()
                               throws SQLException

Is some form of outer join supported?

Specified by:
  `supportsOuterJoins` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsFullOuterJoins

    public boolean supportsFullOuterJoins()
                                   throws SQLException

Are full nested outer joins supported?

Specified by:
  `supportsFullOuterJoins` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsLimitedOuterJoins

    public boolean supportsLimitedOuterJoins()
                                      throws SQLException

Is there limited support for outer joins? (This will be true if supportFullOuterJoins is true.)

Specified by:
  `supportsLimitedOuterJoins` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### getSchemaTerm

    public String getSchemaTerm()
                         throws SQLException

What's the database vendor's preferred term for "schema"?

Specified by:
  `getSchemaTerm` in interface `DatabaseMetaData`
Returns:
  the vendor term
Throws:
  `SQLException`

#### getProcedureTerm

    public String getProcedureTerm()
                            throws SQLException

What's the database vendor's preferred term for "procedure"?

Specified by:
  `getProcedureTerm` in interface `DatabaseMetaData`
Returns:
  the vendor term
Throws:
  `SQLException`

#### getCatalogTerm

    public String getCatalogTerm()
                          throws SQLException

What's the database vendor's preferred term for "catalog"?

Specified by:
  `getCatalogTerm` in interface `DatabaseMetaData`
Returns:
  the vendor term
Throws:
  `SQLException`

#### isCatalogAtStart

    public boolean isCatalogAtStart()
                             throws SQLException

Does a catalog appear at the start of a qualified table name? (Otherwise it appears at the end)

Specified by:
  `isCatalogAtStart` in interface `DatabaseMetaData`
Returns:
  true if it appears at the start
Throws:
  `SQLException`

#### getCatalogSeparator

    public String getCatalogSeparator()
                               throws SQLException

What's the separator between catalog and table name?

Specified by:
  `getCatalogSeparator` in interface `DatabaseMetaData`
Returns:
  the separator string
Throws:
  `SQLException`

#### supportsSchemasInDataManipulation

    public boolean supportsSchemasInDataManipulation()
                                              throws SQLException

Can a schema name be used in a data manipulation statement?

Specified by:
  `supportsSchemasInDataManipulation` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsSchemasInProcedureCalls

    public boolean supportsSchemasInProcedureCalls()
                                            throws SQLException

Can a schema name be used in a procedure call statement?

Specified by:
  `supportsSchemasInProcedureCalls` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsSchemasInTableDefinitions

    public boolean supportsSchemasInTableDefinitions()
                                              throws SQLException

Can a schema name be used in a table definition statement?

Specified by:
  `supportsSchemasInTableDefinitions` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsSchemasInIndexDefinitions

    public boolean supportsSchemasInIndexDefinitions()
                                              throws SQLException

Can a schema name be used in an index definition statement?

Specified by:
  `supportsSchemasInIndexDefinitions` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsSchemasInPrivilegeDefinitions

    public boolean supportsSchemasInPrivilegeDefinitions()
                                                  throws SQLException

Can a schema name be used in a privilege definition statement?

Specified by:
  `supportsSchemasInPrivilegeDefinitions` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsCatalogsInDataManipulation

    public boolean supportsCatalogsInDataManipulation()
                                               throws SQLException

Can a catalog name be used in a data manipulation statement?

Specified by:
  `supportsCatalogsInDataManipulation` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsCatalogsInProcedureCalls

    public boolean supportsCatalogsInProcedureCalls()
                                             throws SQLException

Can a catalog name be used in a procedure call statement?

Specified by:
  `supportsCatalogsInProcedureCalls` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsCatalogsInTableDefinitions

    public boolean supportsCatalogsInTableDefinitions()
                                               throws SQLException

Can a catalog name be used in a table definition statement?

Specified by:
  `supportsCatalogsInTableDefinitions` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsCatalogsInIndexDefinitions

    public boolean supportsCatalogsInIndexDefinitions()
                                               throws SQLException

Can a catalog name be used in a index definition statement?

Specified by:
  `supportsCatalogsInIndexDefinitions` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsCatalogsInPrivilegeDefinitions

    public boolean supportsCatalogsInPrivilegeDefinitions()
                                                   throws SQLException

Can a catalog name be used in a privilege definition statement?

Specified by:
  `supportsCatalogsInPrivilegeDefinitions` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsPositionedDelete

    public boolean supportsPositionedDelete()
                                     throws SQLException

Is positioned DELETE supported? NOTE: Though Oracle supports positional delete through the use of ROWID positional delete as specified by SQLJ92 standard is not supported which is being followed by JDBC 2.1 API Spec.

Specified by:
  `supportsPositionedDelete` in interface `DatabaseMetaData`
Returns:
  false
Throws:
  `SQLException`

#### supportsPositionedUpdate

    public boolean supportsPositionedUpdate()
                                     throws SQLException

Is positioned UPDATE supported? NOTE: Though Oracle supports positional updates through the use of ROWID positional updates as specified by SQLJ92 standard is not supported which is being followed by JDBC 2.1 API Spec.

Specified by:
  `supportsPositionedUpdate` in interface `DatabaseMetaData`
Returns:
  false
Throws:
  `SQLException`

#### supportsSelectForUpdate

    public boolean supportsSelectForUpdate()
                                    throws SQLException

Is SELECT for UPDATE supported?

Specified by:
  `supportsSelectForUpdate` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsStoredProcedures

    public boolean supportsStoredProcedures()
                                     throws SQLException

Are stored procedure calls using the stored procedure escape syntax supported?

Specified by:
  `supportsStoredProcedures` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsSubqueriesInComparisons

    public boolean supportsSubqueriesInComparisons()
                                            throws SQLException

Are subqueries in comparison expressions supported? A JDBC compliant driver always returns true.

Specified by:
  `supportsSubqueriesInComparisons` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsSubqueriesInExists

    public boolean supportsSubqueriesInExists()
                                       throws SQLException

Are subqueries in exists expressions supported? A JDBC compliant driver always returns true.

Specified by:
  `supportsSubqueriesInExists` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsSubqueriesInIns

    public boolean supportsSubqueriesInIns()
                                    throws SQLException

Are subqueries in "in" statements supported? A JDBC compliant driver always returns true.

Specified by:
  `supportsSubqueriesInIns` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsSubqueriesInQuantifieds

    public boolean supportsSubqueriesInQuantifieds()
                                            throws SQLException

Are subqueries in quantified expressions supported? A JDBC compliant driver always returns true.

Specified by:
  `supportsSubqueriesInQuantifieds` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsCorrelatedSubqueries

    public boolean supportsCorrelatedSubqueries()
                                         throws SQLException

Are correlated subqueries supported? A JDBC compliant driver always returns true.

Specified by:
  `supportsCorrelatedSubqueries` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsUnion

    public boolean supportsUnion()
                          throws SQLException

Is SQL UNION supported?

Specified by:
  `supportsUnion` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsUnionAll

    public boolean supportsUnionAll()
                             throws SQLException

Is SQL UNION ALL supported?

Specified by:
  `supportsUnionAll` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsOpenCursorsAcrossCommit

    public boolean supportsOpenCursorsAcrossCommit()
                                            throws SQLException

Can cursors remain open across commits?

Specified by:
  `supportsOpenCursorsAcrossCommit` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`
See Also:
  `Connection#disableAutoClose`

#### supportsOpenCursorsAcrossRollback

    public boolean supportsOpenCursorsAcrossRollback()
                                              throws SQLException

Can cursors remain open across rollbacks?

Specified by:
  `supportsOpenCursorsAcrossRollback` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`
See Also:
  `Connection#disableAutoClose`

#### supportsOpenStatementsAcrossCommit

    public boolean supportsOpenStatementsAcrossCommit()
                                               throws SQLException

Can statements remain open across commits?

Specified by:
  `supportsOpenStatementsAcrossCommit` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`
See Also:
  `Connection#disableAutoClose`

#### supportsOpenStatementsAcrossRollback

    public boolean supportsOpenStatementsAcrossRollback()
                                                 throws SQLException

Can statements remain open across rollbacks?

Specified by:
  `supportsOpenStatementsAcrossRollback` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`
See Also:
  `Connection#disableAutoClose`

#### getMaxBinaryLiteralLength

    public int getMaxBinaryLiteralLength()
                                  throws SQLException

How many hex characters can you have in an inline binary literal?

Specified by:
  `getMaxBinaryLiteralLength` in interface `DatabaseMetaData`
Returns:
  max literal length
Throws:
  `SQLException`

#### getMaxCharLiteralLength

    public int getMaxCharLiteralLength()
                                throws SQLException

What's the max length for a character literal?

Specified by:
  `getMaxCharLiteralLength` in interface `DatabaseMetaData`
Returns:
  max literal length
Throws:
  `SQLException`

#### getIdentifierLength

    protected int getIdentifierLength()
                               throws SQLException

Throws:
  `SQLException`

#### getMaxColumnNameLength

    public int getMaxColumnNameLength()
                               throws SQLException

What's the limit on column name length?

Specified by:
  `getMaxColumnNameLength` in interface `DatabaseMetaData`
Returns:
  max literal length
Throws:
  `SQLException`

#### getMaxColumnsInGroupBy

    public int getMaxColumnsInGroupBy()
                               throws SQLException

What's the maximum number of columns in a "GROUP BY" clause?

Specified by:
  `getMaxColumnsInGroupBy` in interface `DatabaseMetaData`
Returns:
  max number of columns
Throws:
  `SQLException`

#### getMaxColumnsInIndex

    public int getMaxColumnsInIndex()
                             throws SQLException

What's the maximum number of columns allowed in an index?

Specified by:
  `getMaxColumnsInIndex` in interface `DatabaseMetaData`
Returns:
  max columns
Throws:
  `SQLException`

#### getMaxColumnsInOrderBy

    public int getMaxColumnsInOrderBy()
                               throws SQLException

What's the maximum number of columns in an "ORDER BY" clause?

Specified by:
  `getMaxColumnsInOrderBy` in interface `DatabaseMetaData`
Returns:
  max columns
Throws:
  `SQLException`

#### getMaxColumnsInSelect

    public int getMaxColumnsInSelect()
                              throws SQLException

What's the maximum number of columns in a "SELECT" list?

Specified by:
  `getMaxColumnsInSelect` in interface `DatabaseMetaData`
Returns:
  max columns
Throws:
  `SQLException`

#### getMaxColumnsInTable

    public int getMaxColumnsInTable()
                             throws SQLException

What's maximum number of columns in a table?

Specified by:
  `getMaxColumnsInTable` in interface `DatabaseMetaData`
Returns:
  max columns
Throws:
  `SQLException`

#### getMaxConnections

    public int getMaxConnections()
                          throws SQLException

How many active connections can we have at a time to this database?

Specified by:
  `getMaxConnections` in interface `DatabaseMetaData`
Returns:
  max connections
Throws:
  `SQLException`

#### getMaxCursorNameLength

    public int getMaxCursorNameLength()
                               throws SQLException

What's the maximum cursor name length?

Specified by:
  `getMaxCursorNameLength` in interface `DatabaseMetaData`
Returns:
  max cursor name length in bytes
Throws:
  `SQLException`

#### getMaxIndexLength

    public int getMaxIndexLength()
                          throws SQLException

What's the maximum length of an index (in bytes)?

Specified by:
  `getMaxIndexLength` in interface `DatabaseMetaData`
Returns:
  max index length in bytes
Throws:
  `SQLException`

#### getMaxSchemaNameLength

    public int getMaxSchemaNameLength()
                               throws SQLException

What's the maximum length allowed for a schema name?

Specified by:
  `getMaxSchemaNameLength` in interface `DatabaseMetaData`
Returns:
  max name length in bytes
Throws:
  `SQLException`

#### getMaxProcedureNameLength

    public int getMaxProcedureNameLength()
                                  throws SQLException

What's the maximum length of a procedure name?

Specified by:
  `getMaxProcedureNameLength` in interface `DatabaseMetaData`
Returns:
  max name length in bytes
Throws:
  `SQLException`

#### getMaxCatalogNameLength

    public int getMaxCatalogNameLength()
                                throws SQLException

What's the maximum length of a catalog name?

Specified by:
  `getMaxCatalogNameLength` in interface `DatabaseMetaData`
Returns:
  max name length in bytes
Throws:
  `SQLException`

#### getMaxRowSize

    public int getMaxRowSize()
                      throws SQLException

What's the maximum length of a single row?

Specified by:
  `getMaxRowSize` in interface `DatabaseMetaData`
Returns:
  max row size in bytes
Throws:
  `SQLException`

#### doesMaxRowSizeIncludeBlobs

    public boolean doesMaxRowSizeIncludeBlobs()
                                       throws SQLException

Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?

Specified by:
  `doesMaxRowSizeIncludeBlobs` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### getMaxStatementLength

    public int getMaxStatementLength()
                              throws SQLException

What's the maximum length of a SQL statement?

Specified by:
  `getMaxStatementLength` in interface `DatabaseMetaData`
Returns:
  max length in bytes
Throws:
  `SQLException`

#### getMaxStatements

    public int getMaxStatements()
                         throws SQLException

How many active statements can we have open at one time to this database?

Specified by:
  `getMaxStatements` in interface `DatabaseMetaData`
Returns:
  the maximum
Throws:
  `SQLException`

#### getMaxTableNameLength

    public int getMaxTableNameLength()
                              throws SQLException

What's the maximum length of a table name?

Specified by:
  `getMaxTableNameLength` in interface `DatabaseMetaData`
Returns:
  max name length in bytes
Throws:
  `SQLException`

#### getMaxTablesInSelect

    public int getMaxTablesInSelect()
                             throws SQLException

What's the maximum number of tables in a SELECT?

Specified by:
  `getMaxTablesInSelect` in interface `DatabaseMetaData`
Returns:
  the maximum
Throws:
  `SQLException`

#### getMaxUserNameLength

    public int getMaxUserNameLength()
                             throws SQLException

What's the maximum length of a user name?

Specified by:
  `getMaxUserNameLength` in interface `DatabaseMetaData`
Returns:
  max name length in bytes
Throws:
  `SQLException`

#### getDefaultTransactionIsolation

    public int getDefaultTransactionIsolation()
                                       throws SQLException

What's the database's default transaction isolation level? The values are defined in java.sql.Connection.

Specified by:
  `getDefaultTransactionIsolation` in interface `DatabaseMetaData`
Returns:
  the default isolation level
Throws:
  `SQLException`
See Also:
  `Connection`

#### supportsTransactions

    public boolean supportsTransactions()
                                 throws SQLException

Are transactions supported? If not, commit is a noop and the isolation level is TRANSACTION_NONE.

Specified by:
  `supportsTransactions` in interface `DatabaseMetaData`
Returns:
  true if transactions are supported
Throws:
  `SQLException`

#### supportsTransactionIsolationLevel

    public boolean supportsTransactionIsolationLevel(int level)
                                              throws SQLException

Does the database support the given transaction isolation level?

Specified by:
  `supportsTransactionIsolationLevel` in interface `DatabaseMetaData`
Parameters:
  `level` - the values are defined in java.sql.Connection
Returns:
  true if so
Throws:
  `SQLException`
See Also:
  `Connection`

#### supportsDataDefinitionAndDataManipulationTransactions

    public boolean supportsDataDefinitionAndDataManipulationTransactions()
                                                                  throws SQLException

Are both data definition and data manipulation statements within a transaction supported?

Specified by:
  `supportsDataDefinitionAndDataManipulationTransactions` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### supportsDataManipulationTransactionsOnly

    public boolean supportsDataManipulationTransactionsOnly()
                                                     throws SQLException

Are only data manipulation statements within a transaction supported?

Specified by:
  `supportsDataManipulationTransactionsOnly` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### dataDefinitionCausesTransactionCommit

    public boolean dataDefinitionCausesTransactionCommit()
                                                  throws SQLException

Does a data definition statement within a transaction force the transaction to commit?

Specified by:
  `dataDefinitionCausesTransactionCommit` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### dataDefinitionIgnoredInTransactions

    public boolean dataDefinitionIgnoredInTransactions()
                                                throws SQLException

Is a data definition statement within a transaction ignored?

Specified by:
  `dataDefinitionIgnoredInTransactions` in interface `DatabaseMetaData`
Returns:
  true if so
Throws:
  `SQLException`

#### getProcedures

    public ResultSet getProcedures(String catalog,
                                   String schemaPattern,
                                   String procedureNamePattern)
                            throws SQLException

Get a description of stored procedures available in a catalog.

Only procedure descriptions matching the schema and procedure name criteria are returned. They are ordered by PROCEDURE_SCHEM, and PROCEDURE_NAME.

Each procedure description has the the following columns:

1. PROCEDURE_CAT String => procedure catalog (may be null)
2. PROCEDURE_SCHEM String => procedure schema (may be null)
3. PROCEDURE_NAME String => procedure name
4. reserved for future use
5. reserved for future use
6. reserved for future use
7. REMARKS String => explanatory comment on the procedure
8. PROCEDURE_TYPE short => kind of procedure:
   - procedureResultUnknown - May return a result
   - procedureNoResult - Does not return a result
   - procedureReturnsResult - Returns a result

Specified by:
  `getProcedures` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `schemaPattern` - a schema name pattern; "" retrieves those without a schema
  `procedureNamePattern` - a procedure name pattern
Returns:
  ResultSet each row is a procedure description
Throws:
  `SQLException`
See Also:
  `getSearchStringEscape()`

#### getProcedureColumns

    public ResultSet getProcedureColumns(String catalog,
                                         String schemaPattern,
                                         String procedureNamePattern,
                                         String columnNamePattern)
                                  throws SQLException

Get a description of a catalog's stored procedure parameters and result columns.

Only descriptions matching the schema, procedure and parameter name criteria are returned. They are ordered by PROCEDURE_SCHEM and PROCEDURE_NAME. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

Each row in the ResultSet is a parameter desription or column description with the following fields:

1. PROCEDURE_CAT String => procedure catalog (may be null) Interpreted as the Oracle Package name.
2. PROCEDURE_SCHEM String => procedure schema (may be null)
3. PROCEDURE_NAME String => procedure name
4. COLUMN_NAME String => column/parameter name
5. COLUMN_TYPE Short => kind of column/parameter:
   - procedureColumnUnknown - nobody knows
   - procedureColumnIn - IN parameter
   - procedureColumnInOut - INOUT parameter
   - procedureColumnOut - OUT parameter
   - procedureColumnReturn - procedure return value
   - procedureColumnResult - result column in ResultSet
6. DATA_TYPE short => SQL type from java.sql.Types
7. TYPE_NAME String => SQL type name
8. PRECISION int => precision
9. LENGTH int => length in bytes of data
10. SCALE short => scale
11. RADIX short => radix
12. NULLABLE short => can it contain NULL?
    - procedureNoNulls - does not allow NULL values
    - procedureNullable - allows NULL values
    - procedureNullableUnknown - nullability unknown
13. REMARKS String => comment describing parameter/column

Note: Some databases may not return the column descriptions for a procedure. Additional columns beyond REMARKS can be defined by the database. These additional columns MUST be accessed by name, not by index.

Oracle Specific:

The catalog argument is taken to mean a package name. Note that this is not a pattern and wildcards are not supported.

Database synonyms may be defined (amoung other things) for a package, for an unpackaged procedure or for a synonym. The combination of synonyms and wildcards in the schemaPattern and procedureNamePattern is supported in a limited way due to complexity and performace issues.

If the schemaPattern does not contain wildcards and the catalog argument is not null and not empty, the values are taken as either a schema + package name or a schema + synonym for a package. If it is a synonym, it will be resolved perhaps through multiple levels of synonyms and the search for the procedureNamePattern and columnNamePatten will be conducted in the resulting package.

If the catalog is null and both the schemaNamePattern and procedureNamePattern do not contain wildcards, the values are taken as either a schema + procedureName or a schema + synonym. If it is a synonym it will be resolved perhaps through multiple levels of synonyms and the search for the columnNamePatten will be conducted in the resulting procedure

Specified by:
  `getProcedureColumns` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `schemaPattern` - a schema name pattern; "" retrieves those without a schema
  `procedureNamePattern` - a procedure name pattern
  `columnNamePattern` - a column name pattern
Returns:
  ResultSet each row is a stored procedure parameter or column description
Throws:
  `SQLException`
See Also:
  `getSearchStringEscape()`

#### getFunctionColumns

    public ResultSet getFunctionColumns(String catalog,
                                        String schemaPattern,
                                        String functionNamePattern,
                                        String columnNamePattern)
                                 throws SQLException

Retrieves a description of the given catalog's system or user function parameters and return type.

Only descriptions matching the schema, function and parameter name criteria are returned. They are ordered by `FUNCTION_CAT`, `FUNCTION_SCHEM`, `FUNCTION_NAME` and `SPECIFIC_ NAME`. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

Each row in the `ResultSet` is a parameter description, column description or return type description with the following fields:

1. FUNCTION_CAT String => function catalog (may be `null`)
2. FUNCTION_SCHEM String => function schema (may be `null`)
3. FUNCTION_NAME String => function name. This is the name used to invoke the function
4. COLUMN_NAME String => column/parameter name
5. COLUMN_TYPE Short => kind of column/parameter:
   - functionColumnUnknown - nobody knows
   - functionColumnIn - IN parameter
   - functionColumnInOut - INOUT parameter
   - functionColumnOut - OUT parameter
   - functionColumnReturn - function return value
   - functionColumnResult - Indicates that the parameter or column is a column in the `ResultSet`
6. DATA_TYPE int => SQL type from java.sql.Types
7. TYPE_NAME String => SQL type name, for a UDT type the type name is fully qualified
8. PRECISION int => precision
9. LENGTH int => length in bytes of data
10. SCALE short => scale - null is returned for data types where SCALE is not applicable.
11. RADIX short => radix
12. NULLABLE short => can it contain NULL.
    - functionNoNulls - does not allow NULL values
    - functionNullable - allows NULL values
    - functionNullableUnknown - nullability unknown
13. REMARKS String => comment describing column/parameter
14. CHAR_OCTET_LENGTH int => the maximum length of binary and character based parameters or columns. For any other datatype the returned value is a NULL
15. ORDINAL_POSITION int => the ordinal position, starting from 1, for the input and output parameters. A value of 0 is returned if this row describes the function's return value. For result set columns, it is the ordinal position of the column in the result set starting from 1.
16. IS_NULLABLE String => ISO rules are used to determine the nullability for a parameter or column.
    - YES --- if the parameter or column can include NULLs
    - NO --- if the parameter or column cannot include NULLs
    - empty string --- if the nullability for the parameter or column is unknown
17. SPECIFIC_NAME String => the name which uniquely identifies this function within its schema. This is a user specified, or DBMS generated, name that may be different then the `FUNCTION_NAME` for example with overload functions

The PRECISION column represents the specified column size for the given parameter or column. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. Null is returned for data types where the column size is not applicable.

Note: If the user defined function in the database has failed to compile, this method returns an empty resultset.

Specified by:
  `getFunctionColumns` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `functionNamePattern` - a procedure name pattern; must match the function name as it is stored in the database
  `columnNamePattern` - a parameter name pattern; must match the parameter or column name as it is stored in the database
Returns:
  `ResultSet` - each row describes a user function parameter, column or return type
Throws:
  `SQLException` - if a database access error occurs
Since:
  1.6
See Also:
  `getSearchStringEscape()`

#### getTables

    public ResultSet getTables(String catalog,
                               String schemaPattern,
                               String tableNamePattern,
                               String[] types)
                        throws SQLException

Get a description of tables available in a catalog.

Only table descriptions matching the catalog, schema, table name and type criteria are returned. They are ordered by TABLE_TYPE, TABLE_SCHEM and TABLE_NAME.

Each table description has the following columns:

1. TABLE_CAT String => table catalog (may be null)
2. TABLE_SCHEM String => table schema (may be null)
3. TABLE_NAME String => table name
4. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
5. TABLE_REMARKS String => explanatory comment on the table

Note: Some databases may not return information for all tables.

Specified by:
  `getTables` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `schemaPattern` - a schema name pattern; "" retrieves those without a schema
  `tableNamePattern` - a table name pattern
  `types` - a list of table types to include; null returns all types
Returns:
  ResultSet each row is a table description
Throws:
  `SQLException`
See Also:
  `getSearchStringEscape()`

#### getSchemas

    public ResultSet getSchemas()
                         throws SQLException

Get the schema names available in this database. The results are ordered by schema name.

The schema columns are:

LI>TABLE_SCHEM String => schema name
1. TABLE_CATALOG String => catalog name always `null`

Specified by:
  `getSchemas` in interface `DatabaseMetaData`
Returns:
  ResultSet each row has a single String column that is a schema name
Throws:
  `SQLException`

#### getCatalogs

    public ResultSet getCatalogs()
                          throws SQLException

Get the catalog names available in this database. The results are ordered by catalog name.

The catalog column is:

1. TABLE_CAT String => catalog name

Specified by:
  `getCatalogs` in interface `DatabaseMetaData`
Returns:
  ResultSet each row has a single String column that is a catalog name
Throws:
  `SQLException`

#### getTableTypes

    public ResultSet getTableTypes()
                            throws SQLException

Get the table types available in this database. The results are ordered by table type.

The table type is:

1. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".

Specified by:
  `getTableTypes` in interface `DatabaseMetaData`
Returns:
  ResultSet each row has a single String column that is a table type
Throws:
  `SQLException`

#### getColumns

    public ResultSet getColumns(String catalog,
                                String schemaPattern,
                                String tableNamePattern,
                                String columnNamePattern)
                         throws SQLException

Get a description of table columns available in a catalog.

Only column descriptions matching the catalog, schema, table and column name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME and ORDINAL_POSITION.

Each column description has the following columns:

1. TABLE_CAT String => table catalog (may be null)
2. TABLE_SCHEM String => table schema (may be null)
3. TABLE_NAME String => table name
4. COLUMN_NAME String => column name
5. DATA_TYPE short => SQL type from java.sql.Types
6. TYPE_NAME String => Data source dependent type name
7. COLUMN_SIZE int => column size. For char or date types this is the maximum number of characters, for numeric or decimal types this is precision.
8. BUFFER_LENGTH is not used.
9. DECIMAL_DIGITS int => the number of fractional digits
10. NUM_PREC_RADIX int => Radix (typically either 10 or 2)
11. NULLABLE int => is NULL allowed?
    - columnNoNulls - might not allow NULL values
    - columnNullable - definitely allows NULL values
    - columnNullableUnknown - nullability unknown
12. REMARKS String => comment describing column (may be null)
13. COLUMN_DEF String => default value (may be null)
14. SQL_DATA_TYPE int => unused
15. SQL_DATETIME_SUB int => unused
16. CHAR_OCTET_LENGTH int => for char types the maximum number of bytes in the column
17. ORDINAL_POSITION int => index of column in table (starting at 1)
18. IS_NULLABLE String => "NO" means column definitely does not allow NULL values; "YES" means the column might allow NULL values. An empty string means nobody knows.
19. SCOPE_CATLOG String => catalog of table that is the scope of a reference attribute (`null` if DATA_TYPE isn't REF)
20. SCOPE_SCHEMA String => schema of table that is the scope of a reference attribute (`null` if the DATA_TYPE isn't REF)
21. SCOPE_TABLE String => table name that this the scope of a reference attribure (`null` if the DATA_TYPE isn't REF)
22. SOURCE_DATA_TYPE short => source type of a distinct type or user-generated Ref type, SQL type from java.sql.Types (`null` if DATA_TYPE isn't DISTINCT or user-generated REF)
23. IS_AUTOINCREMENT String => Indicates whether this column is auto incremented
    - YES --- if the column is auto incremented
    - NO --- if the column is not auto incremented
    - empty string --- if it cannot be determined whether the column is auto incremented parameter is unknown

Specified by:
  `getColumns` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `schemaPattern` - a schema name pattern; "" retrieves those without a schema
  `tableNamePattern` - a table name pattern
  `columnNamePattern` - a column name pattern
Returns:
  ResultSet each row is a column description
Throws:
  `SQLException`
See Also:
  `getSearchStringEscape()`

#### getColumnPrivileges

    public ResultSet getColumnPrivileges(String catalog,
                                         String schemaPattern,
                                         String tableNamePattern,
                                         String columnNamePattern)
                                  throws SQLException

Get a description of the access rights for a table's columns.

Only privileges matching the column name criteria are returned. They are ordered by COLUMN_NAME and PRIVILEGE.

Each privilige description has the following columns:

1. TABLE_CAT String => table catalog (may be null)
2. TABLE_SCHEM String => table schema (may be null)
3. TABLE_NAME String => table name
4. COLUMN_NAME String => column name
5. GRANTOR => grantor of access (may be null)
6. GRANTEE String => grantee of access
7. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
8. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; null if unknown

Specified by:
  `getColumnPrivileges` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `schemaPattern` - a schema name; "" retrieves those without a schema
  `tableNamePattern` - a table name
  `columnNamePattern` - a column name pattern
Returns:
  ResultSet each row is a column privilege description
Throws:
  `SQLException`
See Also:
  `getSearchStringEscape()`

#### getTablePrivileges

    public ResultSet getTablePrivileges(String catalog,
                                        String schemaPattern,
                                        String tableNamePattern)
                                 throws SQLException

Get a description of the access rights for each table available in a catalog.

Only privileges matching the schema and table name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME, and PRIVILEGE.

Each privilige description has the following columns:

1. TABLE_CAT String => table catalog (may be null)
2. TABLE_SCHEM String => table schema (may be null)
3. TABLE_NAME String => table name
4. COLUMN_NAME String => column name
5. GRANTOR => grantor of access (may be null)
6. GRANTEE String => grantee of access
7. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
8. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; null if unknown

Specified by:
  `getTablePrivileges` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `schemaPattern` - a schema name pattern; "" retrieves those without a schema
  `tableNamePattern` - a table name pattern
Returns:
  ResultSet each row is a table privilege description
Throws:
  `SQLException`
See Also:
  `getSearchStringEscape()`

#### getBestRowIdentifier

    public ResultSet getBestRowIdentifier(String catalog,
                                          String schema,
                                          String table,
                                          int scope,
                                          boolean nullable)
                                   throws SQLException

Get a description of a table's optimal set of columns that uniquely identifies a row. They are ordered by SCOPE.

Each column description has the following columns:

1. SCOPE short => actual scope of result
   - bestRowTemporary - very temporary, while using row
   - bestRowTransaction - valid for remainder of current transaction
   - bestRowSession - valid for remainder of current session
2. COLUMN_NAME String => column name
3. DATA_TYPE short => SQL data type from java.sql.Types
4. TYPE_NAME String => Data source dependent type name
5. COLUMN_SIZE int => precision
6. BUFFER_LENGTH int => not used
7. DECIMAL_DIGITS short => scale
8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
   - bestRowUnknown - may or may not be pseudo column
   - bestRowNotPseudo - is NOT a pseudo column
   - bestRowPseudo - is a pseudo column

Specified by:
  `getBestRowIdentifier` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `schema` - a schema name; "" retrieves those without a schema
  `table` - a table name
  `scope` - the scope of interest; use same values as SCOPE
  `nullable` - include columns that are nullable?
Returns:
  ResultSet each row is a column description
Throws:
  `SQLException`

#### getVersionColumns

    public ResultSet getVersionColumns(String catalog,
                                       String schema,
                                       String table)
                                throws SQLException

Get a description of a table's columns that are automatically updated when any value in a row is updated. They are unordered.

Each column description has the following columns:

1. SCOPE short => is not used
2. COLUMN_NAME String => column name
3. DATA_TYPE short => SQL data type from java.sql.Types
4. TYPE_NAME String => Data source dependent type name
5. COLUMN_SIZE int => precision
6. BUFFER_LENGTH int => length of column value in bytes
7. DECIMAL_DIGITS short => scale
8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
   - versionColumnUnknown - may or may not be pseudo column
   - versionColumnNotPseudo - is NOT a pseudo column
   - versionColumnPseudo - is a pseudo column

Specified by:
  `getVersionColumns` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `schema` - a schema name; "" retrieves those without a schema
  `table` - a table name
Returns:
  ResultSet each row is a column description
Throws:
  `SQLException`

#### getPrimaryKeys

    public ResultSet getPrimaryKeys(String catalog,
                                    String schema,
                                    String table)
                             throws SQLException

Get a description of a table's primary key columns. They are ordered by COLUMN_NAME.

Each column description has the following columns:

1. TABLE_CAT String => table catalog (may be null)
2. TABLE_SCHEM String => table schema (may be null)
3. TABLE_NAME String => table name
4. COLUMN_NAME String => column name
5. KEY_SEQ short => sequence number within primary key
6. PK_NAME String => primary key name (may be null)

Specified by:
  `getPrimaryKeys` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `schema` - a schema name pattern; "" retrieves those without a schema
  `table` - a table name
Returns:
  ResultSet each row is a primary key column description
Throws:
  `SQLException`

#### getImportedKeys

    public ResultSet getImportedKeys(String catalog,
                                     String schema,
                                     String table)
                              throws SQLException

Get a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table). They are ordered by PKTABLE_CAT, PKTABLE_SCHEM, PKTABLE_NAME, and KEY_SEQ.

Each primary key column description has the following columns:

1. PKTABLE_CAT String => primary key table catalog being imported (may be null)
2. PKTABLE_SCHEM String => primary key table schema being imported (may be null)
3. PKTABLE_NAME String => primary key table name being imported
4. PKCOLUMN_NAME String => primary key column name being imported
5. FKTABLE_CAT String => foreign key table catalog (may be null)
6. FKTABLE_SCHEM String => foreign key table schema (may be null)
7. FKTABLE_NAME String => foreign key table name
8. FKCOLUMN_NAME String => foreign key column name
9. KEY_SEQ short => sequence number within foreign key
10. UPDATE_RULE short => What happens to foreign key when primary is updated:
    - importedKeyCascade - change imported key to agree with primary key update
    - importedKeyRestrict - do not allow update of primary key if it has been imported
    - importedKeySetNull - change imported key to NULL if its primary key has been updated
11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
    - importedKeyCascade - delete rows that import a deleted key
    - importedKeyRestrict - do not allow delete of primary key if it has been imported
    - importedKeySetNull - change imported key to NULL if its primary key has been deleted
12. FK_NAME String => foreign key name (may be null)
13. PK_NAME String => primary key name (may be null)

Specified by:
  `getImportedKeys` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `schema` - a schema name pattern; "" retrieves those without a schema
  `table` - a table name
Returns:
  ResultSet each row is a primary key column description
Throws:
  `SQLException`
See Also:
  `getExportedKeys(java.lang.String, java.lang.String, java.lang.String)`

#### getExportedKeys

    public ResultSet getExportedKeys(String catalog,
                                     String schema,
                                     String table)
                              throws SQLException

Get a description of a foreign key columns that reference a table's primary key columns (the foreign keys exported by a table). They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

Each foreign key column description has the following columns:

1. PKTABLE_CAT String => primary key table catalog (may be null)
2. PKTABLE_SCHEM String => primary key table schema (may be null)
3. PKTABLE_NAME String => primary key table name
4. PKCOLUMN_NAME String => primary key column name
5. FKTABLE_CAT String => foreign key table catalog (may be null) being exported (may be null)
6. FKTABLE_SCHEM String => foreign key table schema (may be null) being exported (may be null)
7. FKTABLE_NAME String => foreign key table name being exported
8. FKCOLUMN_NAME String => foreign key column name being exported
9. KEY_SEQ short => sequence number within foreign key
10. UPDATE_RULE short => What happens to foreign key when primary is updated:
    - importedKeyCascade - change imported key to agree with primary key update
    - importedKeyRestrict - do not allow update of primary key if it has been imported
    - importedKeySetNull - change imported key to NULL if its primary key has been updated
11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
    - importedKeyCascade - delete rows that import a deleted key
    - importedKeyRestrict - do not allow delete of primary key if it has been imported
    - importedKeySetNull - change imported key to NULL if its primary key has been deleted
12. FK_NAME String => foreign key identifier (may be null)
13. PK_NAME String => primary key identifier (may be null)

Specified by:
  `getExportedKeys` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `schema` - a schema name pattern; "" retrieves those without a schema
  `table` - a table name
Returns:
  ResultSet each row is a foreign key column description
Throws:
  `SQLException`
See Also:
  `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`

#### getCrossReference

    public ResultSet getCrossReference(String primaryCatalog,
                                       String primarySchema,
                                       String primaryTable,
                                       String foreignCatalog,
                                       String foreignSchema,
                                       String foreignTable)
                                throws SQLException

Get a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key.) This should normally return a single foreign key/primary key pair (most tables only import a foreign key from a table once.) They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

Each foreign key column description has the following columns:

1. PKTABLE_CAT String => primary key table catalog (may be null)
2. PKTABLE_SCHEM String => primary key table schema (may be null)
3. PKTABLE_NAME String => primary key table name
4. PKCOLUMN_NAME String => primary key column name
5. FKTABLE_CAT String => foreign key table catalog (may be null) being exported (may be null)
6. FKTABLE_SCHEM String => foreign key table schema (may be null) being exported (may be null)
7. FKTABLE_NAME String => foreign key table name being exported
8. FKCOLUMN_NAME String => foreign key column name being exported
9. KEY_SEQ short => sequence number within foreign key
10. UPDATE_RULE short => What happens to foreign key when primary is updated:
    - importedKeyCascade - change imported key to agree with primary key update
    - importedKeyRestrict - do not allow update of primary key if it has been imported
    - importedKeySetNull - change imported key to NULL if its primary key has been updated
11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
    - importedKeyCascade - delete rows that import a deleted key
    - importedKeyRestrict - do not allow delete of primary key if it has been imported
    - importedKeySetNull - change imported key to NULL if its primary key has been deleted
12. FK_NAME String => foreign key identifier (may be null)
13. PK_NAME String => primary key identifier (may be null)

Specified by:
  `getCrossReference` in interface `DatabaseMetaData`
Parameters:
  `primaryCatalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `primarySchema` - a schema name pattern; "" retrieves those without a schema
  `primaryTable` - the table name that exports the key
  `foreignCatalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `foreignSchema` - a schema name pattern; "" retrieves those without a schema
  `foreignTable` - the table name that imports the key
Returns:
  ResultSet each row is a foreign key column description
Throws:
  `SQLException`
See Also:
  `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`

#### getTypeInfo

    public ResultSet getTypeInfo()
                          throws SQLException

Get a description of all the standard SQL types supported by this database. They are ordered by DATA_TYPE and then by how closely the data type maps to the corresponding JDBC SQL type.

Each type description has the following columns:

1. TYPE_NAME String => Type name
2. DATA_TYPE short => SQL data type from java.sql.Types
3. PRECISION int => maximum precision
4. LITERAL_PREFIX String => prefix used to quote a literal (may be null)
5. LITERAL_SUFFIX String => suffix used to quote a literal (may be null)
6. CREATE_PARAMS String => parameters used in creating the type (may be null)
7. NULLABLE short => can you use NULL for this type?
   - typeNoNulls - does not allow NULL values
   - typeNullable - allows NULL values
   - typeNullableUnknown - nullability unknown
8. CASE_SENSITIVE boolean=> is it case sensitive?
9. SEARCHABLE short => can you use "WHERE" based on this type:
   - typePredNone - No support
   - typePredChar - Only supported with WHERE .. LIKE
   - typePredBasic - Supported except for WHERE .. LIKE
   - typeSearchable - Supported for all WHERE ..
10. UNSIGNED_ATTRIBUTE boolean => is it unsigned?
11. FIXED_PREC_SCALE boolean => can it be a money value?
12. AUTO_INCREMENT boolean => can it be used for an auto-increment value?
13. LOCAL_TYPE_NAME String => localized version of type name (may be null)
14. MINIMUM_SCALE short => minimum scale supported
15. MAXIMUM_SCALE short => maximum scale supported
16. SQL_DATA_TYPE int => unused
17. SQL_DATETIME_SUB int => unused
18. NUM_PREC_RADIX int => usually 2 or 10

Specified by:
  `getTypeInfo` in interface `DatabaseMetaData`
Returns:
  ResultSet each row is a SQL type description
Throws:
  `SQLException`

#### getIndexInfo

    public ResultSet getIndexInfo(String catalog,
                                  String schema,
                                  String table,
                                  boolean unique,
                                  boolean approximate)
                           throws SQLException

Get a description of a table's indices and statistics. They are ordered by NON_UNIQUE, TYPE, INDEX_NAME, and ORDINAL_POSITION.

Each index column description has the following columns:

1. TABLE_CAT String => table catalog (may be null)
2. TABLE_SCHEM String => table schema (may be null)
3. TABLE_NAME String => table name
4. NON_UNIQUE boolean => Can index values be non-unique? false when TYPE is tableIndexStatistic
5. INDEX_QUALIFIER String => index catalog (may be null); null when TYPE is tableIndexStatistic
6. INDEX_NAME String => index name; null when TYPE is tableIndexStatistic
7. TYPE short => index type:
   - tableIndexStatistic - this identifies table statistics that are returned in conjuction with a table's index descriptions
   - tableIndexClustered - this is a clustered index
   - tableIndexHashed - this is a hashed index
   - tableIndexOther - this is some other style of index
8. ORDINAL_POSITION short => column sequence number within index; zero when TYPE is tableIndexStatistic
9. COLUMN_NAME String => column name; null when TYPE is tableIndexStatistic
10. ASC_OR_DESC String => column sort sequence, "A" => ascending, "D" => descending, may be null if sort sequence is not supported; null when TYPE is tableIndexStatistic
11. CARDINALITY int => When TYPE is tableIndexStatisic then this is the number of rows in the table; otherwise it is the number of unique values in the index.
12. PAGES int => When TYPE is tableIndexStatisic then this is the number of pages used for the table, otherwise it is the number of pages used for the current index.
13. FILTER_CONDITION String => Filter condition, if any. (may be null)

Specified by:
  `getIndexInfo` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
  `schema` - a schema name pattern; "" retrieves those without a schema
  `table` - a table name
  `unique` - when true, return only indices for unique values; when false, return indices regardless of whether unique or not
  `approximate` - when true, result is allowed to reflect approximate or out of data values; when false, results are requested to be accurate

  Note: The schema and table names may be used internally to create a query to get further information from the database. They must conform to the Oracle schema object naming rules. Examples of valid names: last_name, horse,"MY-TEST", "EVEN THIS & THAT!"

Returns:
  ResultSet each row is an index column description
Throws:
  `SQLException`

#### supportsResultSetType

    public boolean supportsResultSetType(int type)
                                  throws SQLException

Implements JDBC 2.0 DatabaseMetaData.supportsResultSetType. Does the database support the given result set type? This method always return true.

Specified by:
  `supportsResultSetType` in interface `DatabaseMetaData`
Parameters:
  `type` - defined in `java.sql.ResultSet`
Returns:
  true always
Throws:
  `SQLException` - if a database access error occurs
See Also:
  `Connection`

#### supportsResultSetConcurrency

    public boolean supportsResultSetConcurrency(int type,
                                                int concurrency)
                                         throws SQLException

Implements JDBC 2.0 DatabaseMetaData.supportsResultSetConcurrency. Does the database support the concurrency type in combination with the given result set type? This method always return true.

Specified by:
  `supportsResultSetConcurrency` in interface `DatabaseMetaData`
Parameters:
  `type` - defined in `java.sql.ResultSet`
  `concurrency` - type defined in `java.sql.ResultSet`
Returns:
  true always
Throws:
  `SQLException` - if a database access error occurs
See Also:
  `Connection`

#### ownUpdatesAreVisible

    public boolean ownUpdatesAreVisible(int type)
                                 throws SQLException

Implements JDBC 2.0 DatabaseMetaData.ownUpdatesAreVisible. Indicates whether a result set's own updates are visible. Return true for scroll-insensitive and scroll-sensitive resultsets.

Specified by:
  `ownUpdatesAreVisible` in interface `DatabaseMetaData`
Parameters:
  `type` - result set type, i.e. ResultSet.TYPE_XXX
Returns:
  `true` if updates are visible for the result set type `false` otherwise
Throws:
  `SQLException` - if a database access error occurs

#### ownDeletesAreVisible

    public boolean ownDeletesAreVisible(int type)
                                 throws SQLException

Implements JDBC 2.0 DatabaseMetaData.ownDeletesAreVisible. Indicates whether a result set's own deletes are visible. Return true for scroll-insensitive and scroll-sensitive resultsets.

Specified by:
  `ownDeletesAreVisible` in interface `DatabaseMetaData`
Parameters:
  `type` - result set type, i.e. ResultSet.TYPE_XXX
Returns:
  `true` if deletes are visible for the result set type `false` otherwise
Throws:
  `SQLException` - if a database access error occurs

#### ownInsertsAreVisible

    public boolean ownInsertsAreVisible(int type)
                                 throws SQLException

Implements JDBC 2.0 DatabaseMetaData.ownInsertsAreVisible. Indicates whether a result set's own inserts are visible. This method always return false in Oracle JDBC driver.

Specified by:
  `ownInsertsAreVisible` in interface `DatabaseMetaData`
Parameters:
  `type` - result set type, i.e. ResultSet.TYPE_XXX
Returns:
  `true` if inserts are visible for the result set type `false` otherwise
Throws:
  `SQLException` - if a database access error occurs

#### othersUpdatesAreVisible

    public boolean othersUpdatesAreVisible(int type)
                                    throws SQLException

Implements JDBC 2.0 DatabaseMetaData.. Indicates whether updates made by others are visible. return true for scroll-sensitive result sets; reutrn false otherwise.

Specified by:
  `othersUpdatesAreVisible` in interface `DatabaseMetaData`
Parameters:
  `type` - result set type, i.e. ResultSet.TYPE_XXX
Returns:
  `true` if updates made by others are visible for the result set type; `false` otherwise
Throws:
  `SQLException` - if a database access error occurs

#### othersDeletesAreVisible

    public boolean othersDeletesAreVisible(int type)
                                    throws SQLException

Implements JDBC 2.0 DatabaseMetaData.. Indicates whether deletes made by others are visible. This method always return false since Oracle JDBC driver doesn't make others changes visible.

Specified by:
  `othersDeletesAreVisible` in interface `DatabaseMetaData`
Parameters:
  `type` - result set type, i.e. ResultSet.TYPE_XXX
Returns:
  `true` if deletes made by others are visible for the result set type; `false` otherwise
Throws:
  `SQLException` - if a database access error occurs

#### othersInsertsAreVisible

    public boolean othersInsertsAreVisible(int type)
                                    throws SQLException

Implements JDBC 2.0 DatabaseMetaData.othersInsertsAreVisible. Indicates whether inserts made by others are visible. This method always return false since Oracle JDBC driver doesn't make others changes visible.

Specified by:
  `othersInsertsAreVisible` in interface `DatabaseMetaData`
Parameters:
  `type` - result set type, i.e. ResultSet.TYPE_XXX
Returns:
  true if updates are visible for the result set type `true` if inserts made by others are visible for the result set type; `false` otherwise
Throws:
  `SQLException` - if a database access error occurs

#### updatesAreDetected

    public boolean updatesAreDetected(int type)
                               throws SQLException

Implements JDBC 2.0 DatabaseMetaData.updatesAreDetected. Indicates whether or not a visible row update can be detected by calling the method `ResultSet.rowUpdated`. This method always return false since Oracle JDBC driver doesn't detect row changes.

Specified by:
  `updatesAreDetected` in interface `DatabaseMetaData`
Parameters:
  `type` - result set type, i.e. ResultSet.TYPE_XXX
Returns:
  `true` if changes are detected by the result set type `false` otherwise
Throws:
  `SQLException` - if a database access error occurs

#### deletesAreDetected

    public boolean deletesAreDetected(int type)
                               throws SQLException

Implements JDBC 2.0 DatabaseMetaData.deletesAreDetected. Indicates whether or not a visible row delete can be detected by calling ResultSet.rowDeleted(). This method always return false since Oracle JDBC driver doesn't detect row changes.

Specified by:
  `deletesAreDetected` in interface `DatabaseMetaData`
Parameters:
  `type` - result set type, i.e. ResultSet.TYPE_XXX
Returns:
  true if changes are detected by the resultset type
Throws:
  `SQLException` - if a database access error occurs

#### insertsAreDetected

    public boolean insertsAreDetected(int type)
                               throws SQLException

Implements JDBC 2.0 DatabaseMetaData.insertsAreDetected. Indicates whether or not a visible row insert can be detected by calling ResultSet.rowInserted(). This method always return false since Oracle JDBC driver doesn't detect row changes.

Specified by:
  `insertsAreDetected` in interface `DatabaseMetaData`
Parameters:
  `type` -
  `type` - result set type, i.e. ResultSet.TYPE_XXX
Returns:
  false always
Throws:
  `SQLException` - if a database access error occurs

#### supportsBatchUpdates

    public boolean supportsBatchUpdates()
                                 throws SQLException

Implements JDBC 2.0 DatabaseMetaData::supportBatchUpdates. Indicates whether the driver supports batch updates.

Specified by:
  `supportsBatchUpdates` in interface `DatabaseMetaData`
Returns:
  true if the driver supports batch updates false otherwise
Throws:
  `SQLException`

#### getUDTs

    public ResultSet getUDTs(String catalog,
                             String schemaPattern,
                             String typeNamePattern,
                             int[] types)
                      throws SQLException

Implements JDBC 2.0 DatabaseMetaData::getUDTs. Gets a description of the STRUCT types defined in a particular schema.

Only types matching the schema, type name and type criteria are returned. They are ordered by DATA_TYPE, TYPE_SCHEM and TYPE_NAME. The type name parameter may be a fully-qualified name. In this case, the catalog and schemaPattern parameters are ignored.

Each type description has the following columns:

1. TYPE_CAT String => the type's catalog which is always null
2. TYPE_SCHEM String => type's schema
3. TYPE_NAME String => type name
4. CLASS_NAME String => Java class name
5. DATA_TYPE String => type value defined in java.sql.Types. Only STRUCT is supported.
6. REMARKS String => explanatory comment on the type

Specified by:
  `getUDTs` in interface `DatabaseMetaData`
Parameters:
  `catalog` - is ignored since Oracle database doesn't support catalog for structured types
  `schemaPattern` - a schema name pattern; "" retrieves those without a schema
  `typeNamePattern` - a type name pattern; may be a fully-qualified name
  `types` - a list of user-named types to include (Oracle only STRUCT) supports; null returns all types
Returns:
  ResultSet - each row is a type description
Throws:
  `SQLException` - if a database access error occurs

#### getConnection

    public Connection getConnection()
                             throws SQLException

Implements JDBC 2.0 DatabaseMetaData.getConnection. Retrieves the connection that produced this metadata object.

Specified by:
  `getConnection` in interface `DatabaseMetaData`
Returns:
  the connection that produced this metadata object
Throws:
  `SQLException`

#### supportsSavepoints

    public boolean supportsSavepoints()
                               throws SQLException

JDBC 3.0 Retrieves whether this database supports savepoints.

Specified by:
  `supportsSavepoints` in interface `DatabaseMetaData`
Returns:
  `true` if savepoints are supported `false` otherwise
Throws:
  `SQLException` - if a database access error occurs
Since:
  9.0.2

#### supportsNamedParameters

    public boolean supportsNamedParameters()
                                    throws SQLException

JDBC 3.0 Retrieves whether this database supports named parameters to callable statements.

Specified by:
  `supportsNamedParameters` in interface `DatabaseMetaData`
Returns:
  `true` if named parameters are supported `false` otherwise
Throws:
  `SQLException` - if a database access error occurs
Since:
  9.0.2

#### supportsMultipleOpenResults

    public boolean supportsMultipleOpenResults()
                                        throws SQLException

JDBC 3.0 Retrieves whether it is possible to have multiple `ResultSet` objects returned from a `CallableStatement` object simultaneously.

Specified by:
  `supportsMultipleOpenResults` in interface `DatabaseMetaData`
Returns:
  `true` if a `CallableStatement` object can return multiple `ResultSet` objects simultaneously; `false` otherwise
Throws:
  `SQLException` - if a datanase access error occurs
Since:
  9.0.2

#### supportsGetGeneratedKeys

    public boolean supportsGetGeneratedKeys()
                                     throws SQLException

JDBC 3.0 Retrieves whether auto-generated keys can be retrieved after a statement has been executed.

Specified by:
  `supportsGetGeneratedKeys` in interface `DatabaseMetaData`
Returns:
  `true` if auto-generated keys can be retrieved after a statement has executed; `false` otherwise
Throws:
  `SQLException` - if a database access error occurs
Since:
  9.0.2

#### getSuperTypes

    public ResultSet getSuperTypes(String catalog,
                                   String schemaPattern,
                                   String typeNamePattern)
                            throws SQLException

JDBC 3.0 Retrieves a description of the user-defined type (UDT) hierarchies defined in a particular schema in this database. Only the immediate super type/sub type relationship is modeled.

Only supertype information for UDTs matching the catalog, schema, and type name is returned. The type name parameter may be a fully-qualified name. When the UDT name supplied is a fully-qualified name, the catalog and schemaPattern parameters are ignored.

If a UDT does not have a direct super type, it is not listed here. A row of the `ResultSet` object returned by this method describes the designated UDT and a direct supertype. A row has the following columns:

1. TYPE_CAT String => the UDT's catalog (may be `null`)
2. TYPE_SCHEM String => UDT's schema (may be `null`)
3. TYPE_NAME String => type name of the UDT
4. SUPERTYPE_CAT String => the direct super type's catalog (may be `null`)
5. SUPERTYPE_SCHEM String => the direct super type's schema (may be `null`)
6. SUPERTYPE_NAME String => the direct super type's name

Note: If the driver does not support type hierarchies, an empty result set is returned.

Specified by:
  `getSuperTypes` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
  `schemaPattern` - a schema name pattern; "" retrieves those without a schema
  `typeNamePattern` - a UDT name pattern; may be a fully-qualified name
Returns:
  a `ResultSet` object in which a row gives information about the designated UDT
Throws:
  `SQLException` - if a database access error occurs
Since:
  9.0.2

#### getSuperTables

    public ResultSet getSuperTables(String catalog,
                                    String schemaPattern,
                                    String tableNamePattern)
                             throws SQLException

JDBC 3.0 Retrieves a description of the table hierarchies defined in a particular schema in this database.

Only supertable information for tables matching the catalog, schema and table name are returned. The table name parameter may be a fully- qualified name, in which case, the catalog and schemaPattern parameters are ignored. If a table does not have a super table, it is not listed here. Supertables have to be defined in the same catalog and schema as the sub tables. Therefore, the type description does not need to include this information for the supertable.

Each type description has the following columns:

1. TABLE_CAT String => the type's catalog (may be `null`)
2. TABLE_SCHEM String => type's schema (may be `null`)
3. TABLE_NAME String => type name
4. SUPERTABLE_NAME String => the direct super type's name

Note: If the driver does not support type hierarchies, an empty result set is returned.

Specified by:
  `getSuperTables` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
  `schemaPattern` - a schema name pattern; "" retrieves those without a schema
  `tableNamePattern` - a table name pattern; may be a fully-qualified name
Returns:
  a `ResultSet` object in which each row is a type description
Throws:
  `SQLException` - if a database access error occurs
Since:
  9.0.2

#### getAttributes

    public ResultSet getAttributes(String catalog,
                                   String schemaPattern,
                                   String typeNamePattern,
                                   String attributeNamePattern)
                            throws SQLException

JDBC 3.0 Retrieves a description of the given attribute of the given type for a user-defined type (UDT) that is available in the given schema and catalog.

Descriptions are returned only for attributes of UDTs matching the catalog, schema, type, and attribute name criteria. They are ordered by TYPE_SCHEM, TYPE_NAME and ORDINAL_POSITION. This description does not contain inherited attributes.

The `ResultSet` object that is returned has the following columns:

1. TYPE_CAT String => type catalog (may be `null`)
2. TYPE_SCHEM String => type schema (may be `null`)
3. TYPE_NAME String => type name
4. ATTR_NAME String => attribute name
5. DATA_TYPE short => attribute type SQL type from java.sql.Types
6. ATTR_TYPE_NAME String => Data source dependent type name. For a UDT, the type name is fully qualified. For a REF, the type name is fully qualified and represents the target type of the reference type.
7. ATTR_SIZE int => column size. For char or date types this is the maximum number of characters; for numeric or decimal types this is precision.
8. DECIMAL_DIGITS int => the number of fractional digits
9. NUM_PREC_RADIX int => Radix (typically either 10 or 2)
10. NULLABLE int => whether NULL is allowed
    - attributeNoNulls - might not allow NULL values
    - attributeNullable - definitely allows NULL values
    - attributeNullableUnknown - nullability unknown
11. REMARKS String => comment describing column (may be `null`)
12. ATTR_DEF String => default value (may be `null`)
13. SQL_DATA_TYPE int => unused
14. SQL_DATETIME_SUB int => unused
15. CHAR_OCTET_LENGTH int => for char types the maximum number of bytes in the column
16. ORDINAL_POSITION int => index of column in table (starting at 1)
17. IS_NULLABLE String => "NO" means column definitely does not allow NULL values; "YES" means the column might allow NULL values. An empty string means unknown.
18. SCOPE_CATALOG String => catalog of table that is the scope of a reference attribute (`null` if DATA_TYPE isn't REF)
19. SCOPE_SCHEMA String => schema of table that is the scope of a reference attribute (`null` if DATA_TYPE isn't REF)
20. SCOPE_TABLE String => table name that is the scope of a reference attribute (`null` if the DATA_TYPE isn't REF)
21. SOURCE_DATA_TYPE short => source type of a distinct type or user-generated Ref type,SQL type from java.sql.Types (`null` if DATA_TYPE isn't DISTINCT or user-generated REF)

Specified by:
  `getAttributes` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `typeNamePattern` - a type name pattern; must match the type name as it is stored in the database
  `attributeNamePattern` - an attribute name pattern; must match the attribute name as it is declared in the database
Returns:
  a `ResultSet` object in which each row is an attribute description
Throws:
  `SQLException` - if a database access error occurs
Since:
  9.0.2

#### supportsResultSetHoldability

    public boolean supportsResultSetHoldability(int holdability)
                                         throws SQLException

JDBC 3.0 Retrieves whether this database supports the given result set holdability.

Specified by:
  `supportsResultSetHoldability` in interface `DatabaseMetaData`
Parameters:
  `holdability` - one of the following constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`or `OracleResultSet.HOLD_CURSORS_OVER_COMMIT for jdk1.2 and jdk1.3` or `OracleResultSet.CLOSE_CURSORS_AT_COMMIT for jdk1.2 and jdk1.3```
Returns:
  `true` if so `false` otherwise
Throws:
  `SQLException` - if a database access error occurs
Since:
  9.0.2
See Also:
  `Connection`

#### getResultSetHoldability

    public int getResultSetHoldability()
                                throws SQLException

JDBC 3.0 Retrieves the default holdability of this `ResultSet` object.

Specified by:
  `getResultSetHoldability` in interface `DatabaseMetaData`
Returns:
  the default holdability either `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT` or `OracleResultSet.HOLD_CURSORS_OVER_COMMIT` for jdk1.2 and jdk1.3 or `OracleResultSet.CLOSE_CURSORS_AT_COMMIT` for jdk1.2 and jdk1.3
Throws:
  `SQLException` - if a database access error occurs
Since:
  9.0.2

#### getDatabaseMajorVersion

    public int getDatabaseMajorVersion()
                                throws SQLException

JDBC 3.0 Retrieves the major version number of the underlying database.

Specified by:
  `getDatabaseMajorVersion` in interface `DatabaseMetaData`
Returns:
  the underlying database's major version
Throws:
  `SQLException` - if a database access error occurs
Since:
  9.0.2

#### getDatabaseMinorVersion

    public int getDatabaseMinorVersion()
                                throws SQLException

JDBC 3.0 Retrieves the minor version number of the underlying database.

Specified by:
  `getDatabaseMinorVersion` in interface `DatabaseMetaData`
Returns:
  underlying database's minor version
Throws:
  `SQLException` - if a database access error occurs
Since:
  9.0.2

#### getJDBCMajorVersion

    public int getJDBCMajorVersion()
                            throws SQLException

JDBC 3.0 Retrieves the major JDBC version number for this driver.

Specified by:
  `getJDBCMajorVersion` in interface `DatabaseMetaData`
Returns:
  JDBC version major number
Throws:
  `SQLException` - if a database access error occurs
Since:
  9.0.2

#### getJDBCMinorVersion

    public int getJDBCMinorVersion()
                            throws SQLException

JDBC 3.0 Retrieves the minor JDBC version number for this driver.

Specified by:
  `getJDBCMinorVersion` in interface `DatabaseMetaData`
Returns:
  JDBC version minor number
Throws:
  `SQLException` - if a database access error occurs
Since:
  9.0.2

#### getSQLStateType

    public int getSQLStateType()
                        throws SQLException

JDBC 3.0 Indicates whether the SQLSTATEs returned by `SQLException.getSQLState` is X/Open (now known as Open Group) SQL CLI or SQL99.

Specified by:
  `getSQLStateType` in interface `DatabaseMetaData`
Returns:
  the type of SQLSTATEs, one of: sqlStateXOpen or sqlStateSQL99
Throws:
  `SQLException` - if a database access error occurs
Since:
  9.0.2

#### locatorsUpdateCopy

    public boolean locatorsUpdateCopy()
                               throws SQLException

JDBC 3.0

Specified by:
  `locatorsUpdateCopy` in interface `DatabaseMetaData`
Returns:
Throws:
  `SQLException`

#### supportsStatementPooling

    public boolean supportsStatementPooling()
                                     throws SQLException

JDBC 3.0

Specified by:
  `supportsStatementPooling` in interface `DatabaseMetaData`
Returns:
Throws:
  `SQLException`

#### getDriverNameInfo

    public static String getDriverNameInfo()
                                    throws SQLException

What's the name of this JDBC driver?

Returns:
  JDBC driver name
Throws:
  `SQLException`

#### getDriverVersionInfo

    public static String getDriverVersionInfo()
                                       throws SQLException

Deprecated. -- use standard getDriverVersion()
What's the version of this JDBC driver?

Returns:
  JDBC driver version
Throws:
  `SQLException`

#### getDriverMajorVersionInfo

    public static int getDriverMajorVersionInfo()

Deprecated. -- use standard getDriverMajorVersion()
What's this JDBC driver's major version number?

Returns:
  JDBC driver major version

#### getDriverMinorVersionInfo

    public static int getDriverMinorVersionInfo()

Deprecated. -- use JDBC standard method getDriverMinorVersion
What's this JDBC driver's minor version number?

Returns:
  JDBC driver minor version number

#### getLobPrecision

    public static String getLobPrecision()
                                  throws SQLException

Deprecated.
This is an internal method that should not be used by customers.

Throws:
  `SQLException`

#### getLobMaxLength

    public long getLobMaxLength()
                         throws SQLException

The max size of a lob on the server for this connection. Note that the actual size available for a particular lob will depend on the specific storage allocation.

Specified by:
  `getLobMaxLength` in interface `AdditionalDatabaseMetaData`
Returns:
  Max size of lob.
Throws:
  `SQLException`

#### getRowIdLifetime

    public RowIdLifetime getRowIdLifetime()
                                   throws SQLException

Oracle rowids are valid across all sessions.

Specified by:
  `getRowIdLifetime` in interface `DatabaseMetaData`
Returns:
  true
Throws:
  `SQLException`
Since:
  11.0

#### getSchemas

    public ResultSet getSchemas(String catalog,
                                String schemaPattern)
                         throws SQLException

Return the schemas that match the given pattern. Oracle does not support catalogs so that parameter is ignored. If the pattern is null that means don't filter using a pattern. Since the catalog is ignored that is the same as the getSchemas() method so call it.

The schema columns are:

1. TABLE_SCHEM String => schema name
2. TABLE_CATALOG String => catalog name always `null`.

Specified by:
  `getSchemas` in interface `DatabaseMetaData`
Parameters:
  `catalog` - ignored
  `schemaPattern` - pattern to match against the schema names
Returns:
  a result set of schema names
Throws:
  `SQLException` - if a database error occurs
Since:
  11.0

#### supportsStoredFunctionsUsingCallSyntax

    public boolean supportsStoredFunctionsUsingCallSyntax()
                                                   throws SQLException

Oracle supports using the JDBC escape syntax to call PLSQL functions.

Specified by:
  `supportsStoredFunctionsUsingCallSyntax` in interface `DatabaseMetaData`
Returns:
  true
Throws:
  `SQLException`
Since:
  11.0

#### autoCommitFailureClosesAllResultSets

    public boolean autoCommitFailureClosesAllResultSets()
                                                 throws SQLException

Oracle does not close ResultSets when autocommit fails.

Specified by:
  `autoCommitFailureClosesAllResultSets` in interface `DatabaseMetaData`
Returns:
  false
Throws:
  `SQLException`
Since:
  11.0

#### getClientInfoProperties

    public ResultSet getClientInfoProperties()
                                      throws SQLException

Specified by:
  `getClientInfoProperties` in interface `DatabaseMetaData`
Throws:
  `SQLException`

#### getFunctions

    public ResultSet getFunctions(String catalog,
                                  String schemaPattern,
                                  String functionNamePattern)
                           throws SQLException

Return a result set that describes the matching functions.

Specified by:
  `getFunctions` in interface `DatabaseMetaData`
Parameters:
  `catalog` - used for the package name
  `schemaPattern` - the schema pattern to match
  `functionNamePattern` - the pattern to match against the function name
Returns:
  a ResultSet that describes the matching functions
Throws:
  `SQLException`
Since:
  11.0

#### isWrapperFor

    public boolean isWrapperFor(Class<?> iface)
                         throws SQLException

Since this class is not a wrapper, just check to see if this implements the requested interface.

Specified by:
  `isWrapperFor` in interface `Wrapper`
Parameters:
  `iface` - requested interface
Returns:
  true iff this implements the requested interface
Throws:
  `SQLException` - if the arg is not an interface
Since:
  JDBC 4.0

#### unwrap

    public <T> T unwrap(Class<T> iface)
                 throws SQLException

Since this class is not a wrapper, just check to see if this implements the requested interface. If it does return this.

Specified by:
  `unwrap` in interface `Wrapper`
Parameters:
  `iface` - requested interface
Returns:
  this iff this implements the requested interface
Throws:
  `SQLException` - if this does not implement the arg or the arg is not an interface
Since:
  JDBC 4.0

#### hasSqlWildcard

    protected boolean hasSqlWildcard(String s)

#### stripSqlEscapes

    protected String stripSqlEscapes(String s)

#### getOracleTypeMetaData

    public OracleTypeMetaData getOracleTypeMetaData(String sqlTypeName)
                                             throws SQLException

Description copied from interface: `AdditionalDatabaseMetaData`
Return the type metadata for a named type. Use this instead of the various Descriptor classes and methods. Use of the Descriptor classes and methods such as oracle.sql.TypeDescriptor, is not recommended and will cause ClassCastException if used with some new Oracle JDBC features.

Specified by:
  `getOracleTypeMetaData` in interface `AdditionalDatabaseMetaData`
Parameters:
  `sqlTypeName` - the name of the type
Returns:
  the metadata for the type
Throws:
  `SQLException` - if the type does not exist or some other error occurs

#### datatypeQuery

    protected String datatypeQuery(OracleDatabaseMetaData.DataTypeSource src)

#### datatypeQuery

    protected String datatypeQuery(OracleDatabaseMetaData.DataTypeSource src,
                                   String table)

#### getPseudoColumns

    public ResultSet getPseudoColumns(String catalog,
                                      String schemaPattern,
                                      String tableNamePattern,
                                      String columnNamePattern)
                               throws SQLException

Specified by:
  `getPseudoColumns` in interface `DatabaseMetaData`
Throws:
  `SQLException`

#### generatedKeyAlwaysReturned

    public boolean generatedKeyAlwaysReturned()
                                       throws SQLException

Specified by:
  `generatedKeyAlwaysReturned` in interface `DatabaseMetaData`
Throws:
  `SQLException`

#### getAuditBanner

    public String getAuditBanner()
                          throws SQLException

Returns the audit banner on this connection.

Specified by:
  `getAuditBanner` in interface `AdditionalDatabaseMetaData`
Returns:
  String containing the audit banner or a null String if there isn't one available on this connection.
Throws:
  `SQLException` - if there is any issue while retrieving the banner

#### getAccessBanner

    public String getAccessBanner()
                           throws SQLException

Returns the access banner on this connection.

Specified by:
  `getAccessBanner` in interface `AdditionalDatabaseMetaData`
Returns:
  String containing the access banner or a null String if there isn't one available on this connection.
Throws:
  `SQLException` - if there is any issue while retrieving the banner

#### isServerBigSCN

    public boolean isServerBigSCN()
                           throws SQLException

Throws:
  `SQLException`

#### isCompatible122OrGreater

    public boolean isCompatible122OrGreater()
                                     throws SQLException

Throws:
  `SQLException`

#### setACProxy

    public void setACProxy(Object w)

Specified by:
  `setACProxy` in interface `oracle.jdbc.internal.ACProxyable`

#### getACProxy

    public Object getACProxy()

Specified by:
  `getACProxy` in interface `oracle.jdbc.internal.ACProxyable`

#### getMonitorLock

    public final oracle.jdbc.internal.Monitor.CloseableLock getMonitorLock()

Specified by:
  `getMonitorLock` in interface `oracle.jdbc.internal.Monitor`

Copyright © 2008, 2020, Oracle and/or its affiliates. All rights reserved.